
template<class T>
struct Combination
{
	int length;
	T* buf;
	T* choices;
	int* choiceIndex;
	int choiceNumber;
	int choiceCounter;
	T* init(int theLength, T* theChoices, int theChoiceNumber);
	T* nextCombination();

};

typedef Combination<int> IntCombination;
typedef Combination<bool> BoolCombination;

template<class T> 
T* Combination<T>::init(int theLength, T* theChoices, int theChoiceNumber)
{
	choiceCounter=0;
	length=theLength;
	choiceNumber=theChoiceNumber;
	choiceIndex=new int[length];
	if (choiceIndex==NULL)
	{
		errHandle("memory");
	}
	buf=new T[length];
	if (buf==NULL)
	{
		errHandle("memory allocation failed");
	}
	choices=new T[choiceNumber];

	if (choices==NULL)
	{
		errHandle("memory allocation failed");
	}
	memcpy(choices, theChoices, sizeof(T)*choiceNumber);
	for (int i=0; i<length; i++)
	{
		buf[i]=choices[0];
		choiceIndex[i]=0;
	}
	return buf;
}

template<class T>
T* Combination<T>::nextCombination()
{
	int index=0;
	while (index<length)
	{
		choiceIndex[index]++;
		buf[index]=choices[choiceIndex[index]%choiceNumber];

		if (choiceIndex[index]==choiceNumber)
		{
			choiceIndex[index]=0;			
			index++;
		}
		else
		{
			break;
		}
	}
	return buf;
}

