#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "myWindow.h"
#include "errHandle.h"
#include "jpegLoader.h"
#include "sprite.h"

extern unsigned int rasterOp[256];
extern HBRUSH hBGBrush;

const int SilhouetteWidth=1;


HDC hMaskDC;
BITMAP bitmap;
HBITMAP hMaskBitmap;
HBITMAP hBitmap;
HDC hdcBitmap;
HDC hMyMaskDC;
HBITMAP hMyMaskBitmap;

HDC hMyDC;



void buildSilhouette(HDC hdc, BITMAP bitmap)
{	
	HBITMAP hMyBitmap;
	hMyDC =CreateCompatibleDC(hdc);
	hMyBitmap=CreateBitmap(bitmap.bmWidth, bitmap.bmHeight, 1, 1, NULL);
	SelectObject(hMyDC, hMyBitmap);

	BitBlt(hMyDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hdc, 0, 0, SRCCOPY );

	BitBlt(hMyDC, SilhouetteWidth, SilhouetteWidth, bitmap.bmWidth-SilhouetteWidth, 
		bitmap.bmHeight-SilhouetteWidth, hdc, 0, 0, SRCPAINT );
	

	BitBlt(hMyDC, 0, 0, bitmap.bmWidth-SilhouetteWidth, bitmap.bmHeight-SilhouetteWidth, 
		hdc, SilhouetteWidth, SilhouetteWidth, SRCPAINT);
	

	 
	BitBlt(hdc, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hMyDC, 0, 0, 0x00990066);
	//BitBlt(hdc, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hMyDC, 0, 0, SRCINVERT);
	
	//DeleteDC(hMyDC);
	//DeleteObject(hBitmap);
}



void createSprite(HWND hwnd, char* fileName, bool jpeg, bool whiteBackground)				  
{
	HDC hdc;
	COLORREF bkgColor, oldBGColor;
	
	hdc=GetDC(hwnd);
	if (jpeg)
	{
		hBitmap=loadJPEGImage(hdc, fileName, bitmap);
	}
	else
	{
		hBitmap=(HBITMAP)LoadImage(NULL, fileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	}

	hdcBitmap=CreateCompatibleDC(hdc);
	hMaskDC=CreateCompatibleDC(hdc);
	hMyMaskDC=CreateCompatibleDC(hdc);

	SelectObject(hdcBitmap, hBitmap);

	bkgColor=GetPixel(hdcBitmap, 0, 0);
		
	hMaskBitmap=CreateBitmap(bitmap.bmWidth, bitmap.bmHeight, 1, 1, NULL);

	hMyMaskBitmap=CreateBitmap(bitmap.bmWidth, bitmap.bmHeight, 1, 1, NULL);

	SelectObject(hMaskDC, hMaskBitmap);
	SelectObject(hMyMaskDC, hMyMaskBitmap);

	oldBGColor=SetBkColor(hdcBitmap, bkgColor);
	BitBlt(hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hdcBitmap, 0, 0, SRCCOPY);

	BitBlt(hMyMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hdcBitmap, 0, 0, SRCCOPY);
	
	SetBkColor(hdcBitmap, oldBGColor);
	if (whiteBackground)
	{
		BitBlt(hdcBitmap, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hMaskDC, 0, 0, SRCINVERT);
	}

	
	//buildSilhouette(hMaskDC, bitmap);

	//BitBlt(hdcBitmap, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hMaskDC, 0, 0, 0x00220326);

	ReleaseDC(hwnd, hdc);
}


/*
long CALLBACK drawMan(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	char buf[80];
	static int startX=-1, startY=-1, endX, endY;
	int currentX, currentY, delta;
	RECT rect;
	unsigned int result;
	
	static int index=0;
	const int Step=10;
	int length, i, j;
	switch (message)
	{
	//case WM_SIZE:

	case WM_CREATE:
		//hBitmap=(HBITMAP)LoadImage(myWindow.hGlobalInstance, "IDMAN", IMAGE_BITMAP, 0, 0, 
		//	LR_DEFAULTCOLOR);


		//hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
		//	LR_LOADFROMFILE);
		//GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		
		createSprite(hwnd, "archer+female-bow-attack1.bmp", false, false);
		SetTimer(hwnd, 1, 1000, NULL);

		
	
		break;

	case WM_SIZE:
		rect.left=currentX;
		rect.top=currentY;
		rect.right=currentX+bitmap.bmWidth;
		rect.bottom=currentY+bitmap.bmHeight;
		InvalidateRect(hwnd, &rect, TRUE);
		break;

	case WM_TIMER:
		if (startX==-1||startY==-1||startX==endX&&startY==endY)
		{
			break;
		}
		length=(int)sqrt((endX-startX)*(endX-startX)+(endY-startY)*(endY-startY));
	
		if (Step>length)
		{
			delta=1;
		}
		else
		{
			delta=length/Step;
		}
		
		currentX=startX+(endX-startX)/delta;
		currentY=startY+(endY-startY)/delta;
		
		hdc=GetDC(hwnd);
		
		reDrawBackground(hdc, startX, startY, bitmap.bmWidth, bitmap.bmHeight);
	
		drawSprite(hdc, hdcBitmap, hMaskDC, currentX, currentY, bitmap.bmWidth, 
			bitmap.bmHeight);


		startX=currentX;
		startY=currentY;
		ReleaseDC(hwnd, hdc);		
		break;
	case WM_LBUTTONDOWN:
		GetClientRect(hwnd, &rect);
		if (startX==-1||startY==-1)
		{
			startX=LOWORD(lParam)+Step+rect.left;
			startY=HIWORD(lParam)+Step+rect.top;
			index=0;			
		}
		else
		{
			index++;
			if (index==256)
			{
				index=0;
			}
		}
		hdc=GetWindowDC(hwnd);

		BitBlt(hdc, rect.left, rect.top, bitmap.bmWidth, bitmap.bmHeight, hMyMaskDC, 0, 0, SRCCOPY);
		BitBlt(hdc, bitmap.bmWidth, bitmap.bmHeight, bitmap.bmWidth, bitmap.bmHeight, 
			hMaskDC, 0, 0, SRCCOPY);

		BitBlt(hdc, rect.left, rect.top+bitmap.bmHeight, bitmap.bmWidth, bitmap.bmHeight, 
			hdcBitmap, 0, 0, SRCCOPY);
		BitBlt(hdc, rect.left+bitmap.bmHeight, rect.top,  bitmap.bmWidth, bitmap.bmHeight, 
			hMyDC, 0, 0, SRCCOPY);
		drawSprite(hdc, hdcBitmap, hMaskDC, startX, startY, bitmap.bmWidth, bitmap.bmHeight);
		
		

		endX=LOWORD(lParam)+rect.left;
		endY=HIWORD(lParam)+rect.top;

		ReleaseDC(hwnd, hdc);		
		break;
	case WM_RBUTTONDOWN:
		index--;
		if (index<0)
		{
			index=0;
		}
		break;
	case WM_DESTROY:
		DeleteDC(hdcBitmap);
		DeleteDC(hMaskDC);
		DeleteObject(hBitmap);
		DeleteObject(hMaskBitmap);
		DeleteDC(hMyMaskDC);
	    DeleteObject(hMyMaskBitmap);
		KillTimer(hwnd, 1);
		break;
	}
	return 0L;
}
*/
/*
long CALLBACK drawMan(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	char buf[80];
	static int startX=-1, startY=-1, endX, endY;
	int currentX, currentY, delta;
	RECT rect;
	unsigned int result;
	
	static int index=0;
	const int Step=10;
	int length, i, j;
	COLORREF bkgColor;
	switch (message)
	{
	//case WM_SIZE:

	case WM_CREATE:
		//hBitmap=(HBITMAP)LoadImage(myWindow.hGlobalInstance, "IDMAN", IMAGE_BITMAP, 0, 0, 
		//	LR_DEFAULTCOLOR);


		hBitmap=(HBITMAP)LoadImage(NULL, "archer.bmp", IMAGE_BITMAP, 0, 0, 
			LR_LOADFROMFILE);
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		hdcBitmap=CreateCompatibleDC(hdc);
		SelectObject(hdcBitmap, hBitmap);

		bkgColor=GetPixel(hdcBitmap, 0, 0);
		
		//createSprite(hwnd, "archer+female-bow-attack1.bmp", false, false);
		SetTimer(hwnd, 1, 1000, NULL);

		
	
		break;

	case WM_SIZE:
		rect.left=currentX;
		rect.top=currentY;
		rect.right=currentX+bitmap.bmWidth;
		rect.bottom=currentY+bitmap.bmHeight;
		InvalidateRect(hwnd, &rect, TRUE);
		break;
		
	case WM_LBUTTONDOWN:
		GetClientRect(hwnd, &rect);
		if (startX==-1||startY==-1)
		{
			startX=LOWORD(lParam)+Step+rect.left;
			startY=HIWORD(lParam)+Step+rect.top;
			index=0;			
		}
		else
		{
			index++;
			if (index==256)
			{
				index=0;
			}
		}
		hdc=GetWindowDC(hwnd);

		TransparentBlt(hdc, startX, startY, bitmap.bmWidth, bitmap.bmHeight, hdcBitmap,
			0, 0, bitmap.bmWidth, bitmap.bmHeight, bkgColor);

	
		endX=LOWORD(lParam)+rect.left;
		endY=HIWORD(lParam)+rect.top;

		ReleaseDC(hwnd, hdc);		
		break;
	case WM_RBUTTONDOWN:
		index--;
		if (index<0)
		{
			index=0;
		}
		break;
	case WM_DESTROY:
		DeleteDC(hdcBitmap);
		DeleteDC(hMaskDC);
		DeleteObject(hBitmap);
		DeleteObject(hMaskBitmap);
		DeleteDC(hMyMaskDC);
	    DeleteObject(hMyMaskBitmap);
		KillTimer(hwnd, 1);
		break;
	}
	return 0L;
}
*/

/*
	sprintf(buf, "startx[%d]starty[%d]endx[%d]endy[%d]index[%d]", startX, startY, 
			endX, endY, index);
		SetWindowText(hwnd, buf);
sprintf(buf, "length[%d]start[%d,%d]current[%d,%d]end[%d,%d]index[%d]", length, 
			startX, startY, currentX, currentY, endX, endY, index);
		SetWindowText(hwnd, buf);
*/