#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "input.h"
#include <memory.h>



int xScreen, yScreen;

HWND hWndGlobal;
HINSTANCE hInstanceGlobal;
HBRUSH hbgBrush;


struct Disk
{
	int id;
	int top;
	int left;
	int width;
	int height;
	COLORREF color;
};





struct MyPaintStruct
{
	int startPeg;
	int endPeg;
	int startDisk;
	int endDisk;
	int diskID;
};





int CALLBACK dialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	char buffer[80];
	double x;
	switch (message)
	{
	case WM_INITDIALOG:
		SetFocus(GetDlgItem(hDlg, ID_INPUT));
		return TRUE;
	case WM_COMMAND:
		if (wParam==ID_OK)
		{
			GetDlgItemText(hDlg, ID_INPUT, buffer, 25);
			EndDialog(hDlg, 133);
			if (sscanf(buffer, "%lf", &x)==1)
			{
				sprintf(buffer, "x=%-6g, x*x=%-6g", x, x*x);			
			}
			else
			{
				sprintf(buffer, "incorrect input");
			}
			SetWindowText(hWndGlobal, buffer);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

static POINT triangle[3], DEF[3];
HPEN  hPen;
HBRUSH  hBrush;


void initMyDraw()
{
	triangle[0].x=triangle[2].x=-400;
	triangle[1].y=triangle[2].y=200;
	triangle[0].y=-300;

	triangle[1].x=-0;

	for (int i=0; i<3; i++)
	{
		DEF[i].x=triangle[i].x+500;
		DEF[i].y=triangle[i].y;
	}
	hPen=CreatePen(PS_SOLID, 10, RGB(0, 0, 255));
	hBrush=CreateSolidBrush(RGB(255, 0, 0));
}

void uninitMyDraw()
{
	DeleteObject(hPen);
	DeleteObject(hBrush);
}

void myDrawProc(HWND hwnd, HDC hdc)
{
	int w, h;

	RECT rect;
	//HDC hdc;
	//PAINTSTRUCT ps;
	HPEN hOldPen;
	HBRUSH hOldBrush;
	//initMyDraw();
	//hdc=BeginPaint(hwnd, &ps);
	GetClientRect(hwnd, &rect);
	w=rect.right;
	h=rect.bottom;

	SetMapMode(hdc, MM_ISOTROPIC);
	SetViewportOrgEx(hdc, w/2, h/2, NULL);

	SetWindowExtEx(hdc, 1000, 1000, NULL);
	SetViewportExtEx(hdc, w, -h, NULL);


	hOldPen=(HPEN)SelectObject(hdc, hPen);
	hOldBrush=(HBRUSH)SelectObject(hdc, GetStockObject(NULL_BRUSH));

	Polygon(hdc, triangle, 3);

	SelectObject(hdc, GetStockObject(NULL_PEN));
	SelectObject(hdc, hBrush);
	Polygon(hdc, DEF, 3);

	DPtoLP(hdc, (LPPOINT)&rect, 2);
	SelectObject(hdc, hPen);
	SelectObject(hdc, GetStockObject(NULL_BRUSH));

	Rectangle(hdc, rect.left+100, rect.top-100, rect.right-100, rect.bottom+100);

	SelectObject(hdc, hOldPen);
	SelectObject(hdc, hOldBrush);
	//EndPaint(hwnd, &ps);
	//uninitMyDraw();
}


/*
long WINAPI myWindProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	char buf[80];
	int result;
	int n=150, i, left, right;
	static LOCALHANDLE hLocMem;
	static HPALETTE hLogPal;

	HPALETTE hOldPalette;

	HDC hdc;
	long w;
	PAINTSTRUCT ps;
	HBRUSH hBrush;
	RECT rect;

	LOGPALETTE* pPal;

	static int xWindow, yWindow, nRightMouseClick=0;

	switch (message)
	{
	case WM_CREATE:
		initMyDraw();

		SetClassLong(hwnd, GCL_HBRBACKGROUND, (LONG)CreateSolidBrush(RGB(128,128,255)));
		hLocMem=LocalAlloc(LPTR, sizeof(LOGPALETTE)+(n-1)*sizeof(PALETTEENTRY));
		if (hLocMem==NULL)
		{
			MessageBox(NULL, "failed to allocate memory", "error", MB_OK);
		}

		pPal=(LOGPALETTE*)LocalLock(hLocMem);
		pPal->palVersion=0x300;
		pPal->palNumEntries=n;
		pPal->palPalEntry[0].peRed=128;
		pPal->palPalEntry[0].peGreen=128;
		pPal->palPalEntry[0].peBlue=255;
		pPal->palPalEntry[0].peFlags=255;
		for (i=1; i<n; i++)
		{
			pPal->palPalEntry[i].peRed=pPal->palPalEntry[i].peGreen
				=(int)(i*255L/(n-1));
			pPal->palPalEntry[i].peBlue=0;
		}
		if ((hLogPal=CreatePalette(pPal))==NULL)
		{
			sprintf(buf, "creating palette failed of #%d", GetLastError());
			MessageBox(NULL, buf, "error", MB_OK);
		}


		break;

	case WM_DESTROY:
		uninitMyDraw();
		DeleteObject(hLogPal);
		DeleteObject((void*)SetClassLong(hwnd, GCL_HBRBACKGROUND, (LONG)GetStockObject(WHITE_BRUSH)));
		LocalUnlock(hLocMem);
		LocalFree(hLocMem);
		PostQuitMessage(0);

		break;
	case WM_SIZE:
		xWindow=LOWORD(lParam);
		yWindow=HIWORD(lParam);
		break;
	case WM_PAINT:
		
		hdc=BeginPaint(hwnd, &ps);

		hOldPalette=(HPALETTE)SelectPalette(hdc, hLogPal, FALSE);
		RealizePalette(hdc);

		GetClientRect(hwnd, &rect);

		rect.top=rect.bottom/4;
		rect.bottom=3*rect.top;

		left=rect.right/6;
		right=5*left;

		w=right-left;
		rect.right=left;
		for (i=1; i<n; i++)
		{
			rect.left=rect.right;
			rect.right=left+(int)(i*w/(n-1));
			hBrush=CreateSolidBrush(PALETTEINDEX(i));
			FillRect(hdc, &rect, hBrush);
			DeleteObject(hBrush);
		}

		SelectPalette(hdc, hOldPalette, FALSE);
		//EndPaint(hwnd, &ps);

	
		myDrawProc(hwnd, hdc);

		
		//hdc=BeginPaint(hwnd, &ps);

		sprintf(buf, "xWindow=%u, yWindow=%u", xWindow, yWindow);
		TextOut(hdc, 10, 10, buf, strlen(buf));
		GetClientRect(hwnd, &rect);

		sprintf(buf, "left=%u, top=%u, right=%u, bottom=%u", rect.left, rect.top,
			rect.right, rect.bottom);

		TextOut(hdc, 10, 30, buf, strlen(buf));

		sprintf(buf, "right mouse button down %u", nRightMouseClick);
		TextOut(hdc, 10, 50, buf, strlen(buf));
	
		EndPaint(hwnd, &ps);
		
		break;
	case WM_LBUTTONDOWN:
		//sprintf(buf, "xScreen=%u, yScreen=%u", xScreen, yScreen);
		//MessageBox(hwnd, buf, "left mouse click", MB_OK);
		

		//result=DialogBox(hInstanceGlobal, "X_INPUT", hWndGlobal, (DLGPROC)dialogProc); 
		result=DialogBox(hInstanceGlobal, "X_INPUT", hWndGlobal, dialogProc); 
		if (result!=133)
		{
			sprintf(buf, "error is %d", GetLastError());
			MessageBox(NULL, buf, "error", MB_OK);
		}
		break;
	case WM_RBUTTONDOWN:
		nRightMouseClick++;
		InvalidateRect(hwnd, NULL, TRUE);
		break;
	case WM_COMMAND:
		buf[0]='\0';
		switch (wParam)
		{
		case IDM_MAMMALS:
			sprintf(buf, "elephant, horse, dog");
			break;
		case IDM_FLOWERS:
			sprintf(buf, "roses, sunflowers, daisy");
			break;
		case IDM_BIRDS:
			sprintf(buf, "sparrows, pigeons, swallows");
			break;
		case IDM_TREES:
			sprintf(buf, "maples, oaks, pines");
			break;
		}
		if (buf[0]!='\0')
		{
			MessageBox(hwnd, buf, "sample", MB_OK);
		}
		break;
	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}
*/

/*
long WINAPI myWindProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int bitmapLen;
	HDC hdc, hdcMem;
	HBITMAP hBitmap, hOldBitmap;
	HICON hicon;
	PAINTSTRUCT ps;
	static RECT rect;

	static int xScreen, yScreen, sizeMan, sizeWoman;
	static bool lButtonPressed, rButtonPressed;


	static int xWindow, yWindow, nRightMouseClick=0;

	switch (message)
	{
	case WM_CREATE:
		break;

	case WM_DESTROY:		
		PostQuitMessage(0);
		break;
	case WM_SIZE:
		xScreen=LOWORD(lParam);
		yScreen=HIWORD(lParam);
		sizeMan=sizeWoman=(xScreen<yScreen?xScreen:yScreen)/4;
		lButtonPressed=rButtonPressed=false;
		
		break;
	case WM_PAINT:		
		hdc=BeginPaint(hwnd, &ps);
		hicon=LoadIcon(hInstanceGlobal, "IDPEOPLE");
		DrawIcon(hdc, xScreen-250, yScreen-250, hicon);
		if (lButtonPressed)
		{
			bitmapLen=32;
			sizeMan/=2;
			hBitmap=LoadBitmap(hInstanceGlobal, "IDMAN");
		}
		else
		{
			if (rButtonPressed)
			{
				bitmapLen=64;
				sizeWoman/=2;
				hBitmap=LoadBitmap(hInstanceGlobal, "IDWOMAN");
			}
		}
		hdcMem=CreateCompatibleDC(hdc);
		hOldBitmap=(HBITMAP)SelectObject(hdcMem, hBitmap);
		StretchBlt(hdc, rect.left, rect.top, rect.right-rect.left, 
			rect.bottom-rect.top, hdcMem, 0, 0, bitmapLen, bitmapLen, SRCCOPY);
		SelectObject(hdcMem, hOldBitmap);
		DeleteDC(hdcMem);	
		EndPaint(hwnd, &ps);		
		break;
	case WM_LBUTTONDOWN:
		lButtonPressed=true;
		rButtonPressed=false;
		rect.left=LOWORD(lParam);
		rect.top=HIWORD(lParam);
		rect.right=rect.left+sizeMan;
		rect.bottom=rect.top+sizeMan;
		InvalidateRect(hwnd, &rect, FALSE);	
		break;
	case WM_RBUTTONDOWN:
		rButtonPressed=true;
		lButtonPressed=false;
		rect.left=LOWORD(lParam);
		rect.top=HIWORD(lParam);
		rect.right=rect.left+sizeWoman;
		rect.bottom=rect.top+sizeWoman;
		InvalidateRect(hwnd, &rect, FALSE);	
		break;
	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}	
*/


long WINAPI myWindProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static bool startDrawing=false;
	static POINT pBegin, pEnd;
	static int colorChoice=0;
	static unsigned char myColor[3]={255,0,0};
	HPEN hPen, hOldPen;
	int oldROP;
	RECT rect;
	POINT point;
	
	HDC hdc;
	switch (message)
	{
	case WM_CREATE:
		break;

	case WM_DESTROY:		
		PostQuitMessage(0);
		break;

	case WM_RBUTTONDOWN:
		colorChoice++;
		memset(myColor, 0, 3);
		myColor[colorChoice%3]=255;
		hdc=GetWindowDC(hwnd);
		GetClientRect(hwnd, &rect);
		/*
		hOldBrush=(HBRUSH)SelectObject(hdc, hBGBrush);

		BitBlt(hdc, 0, 0, rect.right-rect.left, rect.bottom-rect.top, hdc, 0, 0, PATCOPY);
		SelectObject(hdc, hOldBrush);
		*/

		
		hPen=CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		hOldPen=(HPEN)SelectObject(hdc, hPen);
		oldROP=SetROP2(hdc, R2_MERGEPEN);

		point.x=point.y=0;
		ClientToScreen(hwnd, &point);
		MoveToEx(hdc, point.x, point.y, NULL);
		point.x=50;
		point.y=50;
		ClientToScreen(hwnd, &point);
		LineTo(hdc, point.x, point.y);
		SetROP2(hdc, oldROP);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);

		ReleaseDC(hwnd, hdc);
		break;
	case WM_LBUTTONDOWN:
		startDrawing=true;
		pBegin.x=LOWORD(lParam);
		pBegin.y=HIWORD(lParam);
		pEnd=pBegin;		
		break;

	case WM_MOUSEMOVE:
		if (startDrawing)
		{
			hdc=GetDC(hwnd);
			SetROP2(hdc, R2_NOT);
			MoveToEx(hdc, pBegin.x, pBegin.y, NULL);
			LineTo(hdc, pEnd.x, pEnd.y);
			pEnd.x=LOWORD(lParam);
			pEnd.y=HIWORD(lParam);

			MoveToEx(hdc, pBegin.x, pBegin.y, NULL);
			LineTo(hdc, pEnd.x, pEnd.y);
			ReleaseDC(hwnd, hdc);
		}
		break;
	case WM_LBUTTONUP:
		hdc=GetDC(hwnd);
		SetROP2(hdc, R2_NOT);
		MoveToEx(hdc, pBegin.x, pBegin.y, NULL);
		LineTo(hdc, pEnd.x, pEnd.y);
		pEnd.x=LOWORD(lParam);
		pEnd.y=HIWORD(lParam);

		hPen=CreatePen(PS_SOLID, 10, RGB(myColor[0], myColor[1], myColor[2]));
		hOldPen=(HPEN)SelectObject(hdc, hPen);
		SetROP2(hdc, R2_COPYPEN);
		MoveToEx(hdc, pBegin.x, pBegin.y, NULL);
		LineTo(hdc, pEnd.x, pEnd.y);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);
		ReleaseDC(hwnd, hdc);
		startDrawing=false;
		break;
	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}	



/*
long WINAPI myWindProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	bool xOut, yOut;
	HDC hdc, hdcMem;
	HBRUSH hBrush;
	HPEN hPen;
	COLORREF yellow=RGB(255, 255, 0);
	static HBITMAP hBitmap=NULL;
	int xScreen, yScreen, R, h, k, nHor, nVer, TotHor, TotVer;
	static int L, x, y, deltaX, deltaY, xMin, xMax, yMin, yMax;
	POINT pentagon[5];
	int width, height;
	const double pi=3.14159;
	double angle;
	RECT rect;
	switch (message)
	{		
	case WM_SIZE:
		xScreen=LOWORD(lParam);
		yScreen=HIWORD(lParam);
		R=(xScreen<yScreen?xScreen:yScreen)/20;
		h=R+1;
		L=2*h;
		nHor=xScreen/L;
		nVer=yScreen/L;
		TotHor=nHor*L;
		TotVer=nVer*L;
		xMin=(xScreen-TotHor)/2;
		xMax=xMin+TotHor-L;
		yMin=(yScreen-TotVer)/2;
		yMax=yMin+TotVer-L;

		x=xMin+(nHor/(rand()%nHor+1))*L;
		y=yMin+ (nVer/(rand()%nVer+1))*L;
		deltaX=deltaY=L;
		for (k=0; k<5; k++)
		{
			angle=pi/2+4*k*(pi/5);
			pentagon[k].x=h+(int)(R*cos(angle));
			pentagon[k].y=h-(int)(R*sin(angle));
		}

		if (hBitmap)
		{
			DeleteObject(hBitmap);
			hBitmap=NULL;
		}
		hdc=GetDC(hwnd);
		SelectObject(hdc, hbgBrush);
		Rectangle(hdc, 0, 0, xScreen, yScreen);
		hdcMem=CreateCompatibleDC(hdc);
		hBitmap=CreateCompatibleBitmap(hdc, L, L);
		ReleaseDC(hwnd, hdc);
		SelectObject(hdcMem, hBitmap);
		SelectObject(hdcMem, GetStockObject(NULL_PEN));
		SelectObject(hdcMem, hbgBrush);
		Rectangle(hdcMem, 0, 0, L+1, L+1);
		hBrush=CreateSolidBrush(yellow);
		hPen=CreatePen(PS_SOLID, 1, yellow);
		SelectObject(hdcMem, hPen);
		SelectObject(hdcMem, hBrush);
		
		SetPolyFillMode(hdcMem, WINDING);
		//SetPolyFillMode(hdcMem, ALTERNATE);
		Polygon(hdcMem, pentagon, 5);
		DeleteDC(hdcMem);
		DeleteObject(hBrush);
		DeleteObject(hPen);

		break;
	case WM_TIMER:
		if (!hBitmap)
		{
			break;
		}
		hdc=GetDC(hwnd);
		hdcMem=CreateCompatibleDC(hdc);
		SelectObject(hdcMem, hBitmap);
		
		SelectObject(hdcMem, GetStockObject(NULL_PEN));
		//hMyBrush=CreateSolidBrush(RGB(0,0,255));

		SelectObject(hdc, hbgBrush);
		//SelectObject(hdc, hMyBrush);

		xOut=(x+deltaX>xMax)||(x+deltaX<xMin);
		yOut=(y+deltaY>yMax)||(y+deltaY<yMin);

		if (xOut)
		{
			deltaX=-deltaX;
		}
		if (yOut)
		{
			deltaY=-deltaY;
		}

		if (!xOut||!yOut)
		{
			x+=deltaX;
			y+=deltaY;
		}
		
		BitBlt(hdc, x, y, L, L, hdcMem, 0, 0, 0x00960169);
		//BitBlt(hdc, x, y, L, L, hdcMem, 0, 0, 0x00EB0849 );
		//DeleteObject(hMyBrush);
		ReleaseDC(hwnd, hdc);
		DeleteDC(hdcMem);
		break;
		
	case WM_DESTROY:
		if (hBitmap)
		{
			DeleteObject(hBitmap);
		}
		KillTimer(hwnd, 1);

		PostQuitMessage(0);
		break;
	case WM_LBUTTONDOWN:

		GetClientRect(hwnd, &rect);
		rect.right/=2;
		rect.bottom/=2;
		width=rect.right-rect.left;
		height=rect.bottom-rect.top;
		SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, width, height, 
			SWP_SHOWWINDOW);
		break;
	default:

		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}
*/

PBITMAPINFO CreateBitmapInfoStruct(HWND hwnd, HBITMAP hBmp)
{ 
    BITMAP bmp; 
    PBITMAPINFO pbmi; 
    WORD    cClrBits; 

    // Retrieve the bitmap's color format, width, and height. 
    if (!GetObject(hBmp, sizeof(BITMAP), (LPSTR)&bmp)) 
	{
        MessageBox(NULL, "GetObject error", "error", MB_OK); 
	}

    // Convert the color format to a count of bits. 
    cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel); 
    if (cClrBits == 1) 
        cClrBits = 1; 
    else if (cClrBits <= 4) 
        cClrBits = 4; 
    else if (cClrBits <= 8) 
        cClrBits = 8; 
    else if (cClrBits <= 16) 
        cClrBits = 16; 
    else if (cClrBits <= 24) 
        cClrBits = 24; 
    else cClrBits = 32; 

    // Allocate memory for the BITMAPINFO structure. (This structure 
    // contains a BITMAPINFOHEADER structure and an array of RGBQUAD 
    // data structures.) 

     if (cClrBits != 24) 
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR, 
                    sizeof(BITMAPINFOHEADER) + 
                    sizeof(RGBQUAD) * (1<< cClrBits)); 

     // There is no RGBQUAD array for the 24-bit-per-pixel format. 

     else 
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR, 
                    sizeof(BITMAPINFOHEADER)); 

    // Initialize the fields in the BITMAPINFO structure. 

    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
    pbmi->bmiHeader.biWidth = bmp.bmWidth; 
    pbmi->bmiHeader.biHeight = bmp.bmHeight; 
    pbmi->bmiHeader.biPlanes = bmp.bmPlanes; 
    pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel; 
    if (cClrBits < 24) 
        pbmi->bmiHeader.biClrUsed = (1<<cClrBits); 

    // If the bitmap is not compressed, set the BI_RGB flag. 
    pbmi->bmiHeader.biCompression = BI_RGB; 

    // Compute the number of bytes in the array of color 
    // indices and store the result in biSizeImage. 
    // For Windows NT/2000, the width must be DWORD aligned unless 
    // the bitmap is RLE compressed. This example shows this. 
    // For Windows 95/98, the width must be WORD aligned unless the 
    // bitmap is RLE compressed.
    pbmi->bmiHeader.biSizeImage = ((pbmi->bmiHeader.biWidth * cClrBits +31) & ~31) /8
                                  * pbmi->bmiHeader.biHeight; 
    // Set biClrImportant to 0, indicating that all of the 
    // device colors are important. 
     pbmi->bmiHeader.biClrImportant = 0; 
     return pbmi; 
 } 



void CreateBMPFile(HWND hwnd, LPTSTR pszFile, PBITMAPINFO pbi, 
                  HBITMAP hBMP, HDC hDC) 
 { 
     HANDLE hf;                 // file handle 
    BITMAPFILEHEADER hdr;       // bitmap file-header 
    PBITMAPINFOHEADER pbih;     // bitmap info-header 
    LPBYTE lpBits;              // memory pointer 
    DWORD dwTotal;              // total count of bytes 
    DWORD cb;                   // incremental count of bytes 
    BYTE *hp;                   // byte pointer 
    DWORD dwTmp; 

    pbih = (PBITMAPINFOHEADER) pbi; 
    lpBits = (LPBYTE) GlobalAlloc(GMEM_FIXED, pbih->biSizeImage);

    if (!lpBits) 
	{
		MessageBox(NULL, "GlobalAlloc error", "error", MB_OK); 
	}

    // Retrieve the color table (RGBQUAD array) and the bits 
    // (array of palette indices) from the DIB. 
    if (!GetDIBits(hDC, hBMP, 0, (WORD) pbih->biHeight, lpBits, pbi, 
        DIB_RGB_COLORS)) 
    {
        MessageBox(NULL, "GetDIBits", "error", MB_OK); 
    }

    // Create the .BMP file. 
    hf = CreateFile(pszFile, 
                   GENERIC_READ | GENERIC_WRITE, 
                   (DWORD) 0, 
                    NULL, 
                   CREATE_ALWAYS, 
                   FILE_ATTRIBUTE_NORMAL, 
                   (HANDLE) NULL); 
    if (hf == INVALID_HANDLE_VALUE) 
	{
		MessageBox(NULL, "CreateFile", "error", MB_OK); 
	}
    hdr.bfType = 0x4d42;        // 0x42 = "B" 0x4d = "M" 
    // Compute the size of the entire file. 
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
                 pbih->biSize + pbih->biClrUsed 
                 * sizeof(RGBQUAD) + pbih->biSizeImage); 
    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 

    // Compute the offset to the array of color indices. 
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
                    pbih->biSize + pbih->biClrUsed 
                    * sizeof (RGBQUAD); 

    // Copy the BITMAPFILEHEADER into the .BMP file. 
    if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER), 
        (LPDWORD) &dwTmp,  NULL)) 
    {
        MessageBox(NULL, "WriteFile", "error", MB_OK); 
    }

    // Copy the BITMAPINFOHEADER and RGBQUAD array into the file. 
    if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER) 
                  + pbih->biClrUsed * sizeof (RGBQUAD), 
                  (LPDWORD) &dwTmp, ( NULL))) 
	{
         MessageBox(NULL, "WriteFile error", "Error", MB_OK); 
	}

    // Copy the array of color indices into the .BMP file. 
    dwTotal = cb = pbih->biSizeImage; 
    hp = lpBits; 
    if (!WriteFile(hf, (LPSTR) hp, (int) cb, (LPDWORD) &dwTmp,NULL)) 
	{
           MessageBox(NULL, "WriteFile", "error", MB_OK);
	}

    // Close the .BMP file. 
     if (!CloseHandle(hf)) 
	 {
           MessageBox(NULL, "CloseHandle", "error", MB_OK); 
	 }

    // Free memory. 
    GlobalFree((HGLOBAL)lpBits);
}

/*
long WINAPI myWindProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	bool xOut, yOut;
	HDC hdc, hdcMem;
	HBRUSH hBrush, hOldBrush;
	HPEN hPen;
	COLORREF yellow=RGB(255, 255, 0);
	static HBITMAP hMyBitmap=NULL, hViewBitmap=NULL;
	static HBRUSH hViewBrush;
	int xScreen, yScreen, R, h, k, nHor, nVer, TotHor, TotVer;
	static int L, x, y, deltaX, deltaY, xMin, xMax, yMin, yMax;
	POINT pentagon[5];
	int width, height;
	const double pi=3.14159;
	double angle;
	RECT rect;
	SIZE mySize;
	BITMAP bitmapInfo;
	BLENDFUNCTION blendFunc;
	PBITMAPINFO pBitmapInfo;
	char buf[80];
	switch (message)
	{
	case WM_CREATE:
		hViewBitmap=(HBITMAP)LoadImage(NULL, "idman.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		hViewBrush=CreatePatternBrush(hViewBitmap);
		break;
	case WM_SIZE:
		/*
		GetClientRect(hwnd, &rect);
			
		hdc=GetDC(hwnd);
		hdcMem=CreateCompatibleDC(hdc);
		if (hMyBitmap==NULL)
		{
			hMyBitmap=(HBITMAP)LoadImage(NULL, "myBrush.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		}
		if (hViewBitmap==NULL)
		{
			hViewBitmap=(HBITMAP)LoadImage(NULL, "myview.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		}	
	
		//SelectObject(hdc, GetStockObject(WHITE_BRUSH));

		hBrush=CreatePatternBrush(hViewBitmap);

		hOldBrush=(HBRUSH)SelectObject(hdc, hBrush);
		SelectObject(hdcMem, hMyBitmap);
		//SelectObject(hdcMem, GetStockObject(NULL_PEN));
		//SelectObject(hdcMem, hBrush);
		//SelectObject(hdc, hBrush);
		//MaskBlt(hdc, 0, 0, rect.right-rect.left, rect.bottom-rect.top, hdcMem, 0, 0, hMyBitmap, 
		//	0, 0, 0x00960169);
		//Rectangle(hdcMem, 0, 0, rect.right-rect.left, rect.bottom-rect.top);
		//Rectangle(hdc, 0, 0, rect.right-rect.left, rect.bottom-rect.top);


		//BitBlt(hdc, 0, 0, rect.right-rect.left, rect.bottom-rect.top, hdcMem, 0, 0, 0x00960169);
		blendFunc.BlendOp=AC_SRC_OVER;
		blendFunc.BlendFlags=0;
		blendFunc.SourceConstantAlpha=50;
		blendFunc.AlphaFormat=AC_SRC_ALPHA ;
		AlphaBlend(hdc, 0, 0, rect.right-rect.left, rect.bottom-rect.top, hdcMem,
			0, 0, rect.right-rect.left, rect.bottom-rect.top, 
		SelectObject(hdc, hOldBrush);
		DeleteObject(hdcMem);
		DeleteObject(hBrush);
		//SelectObject(hdc, hbgBrush);
		ReleaseDC(hwnd, hdc);			
		
		*/
		/*
		break;

	case WM_PAINT:

		//hBitmap=(HBITMAP)LoadImage(NULL, "idview.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		
		
		//

		break;
	case WM_TIMER:
	
		break;
		
	case WM_DESTROY:
		if (hMyBitmap)
		{
			DeleteObject(hMyBitmap);
		}
		DeleteObject(hViewBrush);
		DeleteObject(hViewBitmap);
		//KillTimer(hwnd, 1);

		PostQuitMessage(0);
		break;
	case WM_RBUTTONDOWN:
		xScreen=LOWORD(lParam);
		yScreen=HIWORD(lParam);
		hdc=GetDC(hwnd);
		hOldBrush=(HBRUSH)SelectObject(hdc, hViewBrush);
		RoundRect(hdc, xScreen, yScreen, xScreen+100, yScreen+50, 5, 8);
		//sprintf(buf, "x=%d, y=%d", xScreen, yScreen);
		//TextOut(hdc, xScreen, yScreen, buf, strlen(buf));
		//MessageBox(hwnd, buf, "rbutton", MB_OK|MB_APPLMODAL);

		SelectObject(hdc, hOldBrush);
		ReleaseDC(hwnd, hdc);
		break;
	case WM_LBUTTONDOWN:
		GetClientRect(hwnd, &rect);
		hdc=CreateDC("DISPLAY", NULL, NULL, NULL);

		xScreen=GetDeviceCaps(hdc, HORZRES);
		yScreen=GetDeviceCaps(hdc, VERTRES);
		
		hdcMem=CreateCompatibleDC(hdc);
		hMyBitmap=CreateCompatibleBitmap(hdc, xScreen, yScreen);
		GetObject(hMyBitmap, sizeof(BITMAP), &bitmapInfo);
		ShowWindow(hwnd, SW_HIDE);
		sprintf(buf, "bmWidth=%u, bmHeight=%u, bmWidthBytes=%u, bmPlanes=%u, bmBitsPixel=%u",
			bitmapInfo.bmWidth, bitmapInfo.bmHeight, bitmapInfo.bmWidthBytes,
			bitmapInfo.bmPlanes, bitmapInfo.bmBitsPixel);

		 
		//MessageBox(NULL, buf, "msg", MB_OK);

		SelectObject(hdcMem, hMyBitmap);
		
		
		BitBlt(hdcMem, 0, 0, xScreen, yScreen, hdc, 0, 0, SRCCOPY);
		//
		pBitmapInfo=CreateBitmapInfoStruct(hwnd, hMyBitmap);
		CreateBMPFile(hwnd, "myscreenshot.bmp", pBitmapInfo, hMyBitmap, hdcMem);
		LocalFree(pBitmapInfo);


		DeleteObject(hMyBitmap);
		DeleteDC(hdcMem);
		DeleteDC(hdc);		
		ShowWindow(hwnd, SW_SHOW); 
		break;
	default:

		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}
*/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpComdLine, int nShowCmd)
{
	WNDCLASS wndClass;
	char buf[80];
	HBITMAP hBitmap;

	const char* szAppName="FirstWindow";
	srand(time(0));
	memset(&wndClass, 0, sizeof(WNDCLASS));
	hInstanceGlobal=hInstance;

	MSG msg;
	xScreen=GetSystemMetrics(SM_CXSCREEN);
	yScreen=GetSystemMetrics(SM_CYSCREEN);
	float*fp=(float*)malloc(34);
	if (!hPrevInstance)
	{
		wndClass.hInstance=hInstance;
		//if ((wndClass.hIcon=LoadIcon(hInstance, "IDPEOPLE"))==NULL)
		if ((wndClass.hIcon=LoadIcon(NULL, IDI_APPLICATION))==NULL)
		{
			sprintf(buf, "load icon failed #%d", GetLastError());
			MessageBox(NULL, buf, "error", MB_OK);
		}
		wndClass.style=CS_HREDRAW|CS_VREDRAW;
		//if ((wndClass.hCursor=LoadCursor(hInstance, "IDBIRD"))==NULL)
		if ((wndClass.hCursor=LoadCursor(NULL, IDC_ARROW))==NULL)
		{
			sprintf(buf, "load cursor failed #%d", GetLastError());
			MessageBox(NULL, buf, "error", MB_OK);
		}

		//hbgBrush=CreateSolidBrush(RGB(0, 0, 255));
		//hbgBrush=CreateHatchBrush(HS_HORIZONTAL, RGB(0, 0, 255));
		//hBitmap=LoadBitmap(hInstanceGlobal, "IDVIEW");
		hBitmap=(HBITMAP)LoadImage(NULL, "idview.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		hbgBrush=CreatePatternBrush(hBitmap);
		wndClass.hbrBackground=hbgBrush;
		//wndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
		wndClass.lpszClassName=szAppName;
		wndClass.lpfnWndProc=myWindProc;
		wndClass.lpszMenuName="SampleMenu";
		if (!RegisterClass(&wndClass))
		{
			return FALSE;
		}
	}

	hWndGlobal=CreateWindow(szAppName, "my first window", WS_OVERLAPPEDWINDOW, 0, 0, xScreen,
		yScreen, NULL, NULL, hInstance, NULL);

	//SetTimer(hWndGlobal, 1, 1000, NULL);
	ShowWindow(hWndGlobal, nShowCmd);
	UpdateWindow(hWndGlobal);

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	DeleteObject(hBitmap);
	DeleteObject(hbgBrush);
	return msg.wParam;
}

