#include <windows.h>
#include <wingdi.h>
#include <stdio.h>
#include <math.h>
#include <vector>
#include "myWindow.h"
#include "util.h"
#include "sprite.h"
#include "errHandle.h"
#include "transform.h"
#include "fishEye.h"
#include "region.h"
#include "combination.h"


#pragma comment(lib, "Msimg32.lib")
#pragma warning(disable : C4786 136)


extern unsigned int rasterOp[256];



Sprite mySprite;
//extern BOOL PngFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName) ;
extern Hex myHex;
extern BackGround myBackGround;
extern char buf[256];

extern FishEye myFishEye;
extern PeekHole myPeekHole;



//-----------------
//  LoadImageFile
//-----------------





void doTransform(int iTransform, XFORM& xForm)
{
	switch (iTransform) 
    { 
    case SCALE:        // Scale to 1/2 of the original size. 
        xForm.eM11 = (FLOAT) 0.5; 
        xForm.eM12 = (FLOAT) 0.0; 
        xForm.eM21 = (FLOAT) 0.0; 
        xForm.eM22 = (FLOAT) 0.5; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 

    case TRANSLATE:   // Translate right by 3/4 inch. 
        xForm.eM11 = (FLOAT) 1.0; 
        xForm.eM12 = (FLOAT) 0.0; 
        xForm.eM21 = (FLOAT) 0.0; 
        xForm.eM22 = (FLOAT) 1.0; 
        xForm.eDx  = (FLOAT) 30.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 

    case ROTATE:      // Rotate 30 degrees counterclockwise. 
        xForm.eM11 = (FLOAT) 0.8660; 
        xForm.eM12 = (FLOAT) 0.5000; 
        xForm.eM21 = (FLOAT) -0.5000; 
        xForm.eM22 = (FLOAT) 0.8660; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 

    case SHEAR:       // Shear along the x-axis with a 
                      // proportionality constant of 1.0. 
        xForm.eM11 = (FLOAT) 1.0; 
        xForm.eM12 = (FLOAT) 1.0; 
        xForm.eM21 = (FLOAT) 0.0; 
        xForm.eM22 = (FLOAT) 1.0; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 

    case REFLECT:     // Reflect about a horizontal axis. 
        xForm.eM11 = (FLOAT) 1.0; 
        xForm.eM12 = (FLOAT) 0.0; 
        xForm.eM21 = (FLOAT) 0.0; 
        xForm.eM22 = (FLOAT) -1.0; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 
		
    case NORMAL:      // Set the unity transformation. 
        xForm.eM11 = (FLOAT) 1.0; 
        xForm.eM12 = (FLOAT) 0.0; 
        xForm.eM21 = (FLOAT) 0.0; 
        xForm.eM22 = (FLOAT) 1.0; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        
        break; 

    } 
}
 


void transformAndDraw(int iTransform, HWND hWnd) 
{ 
    HDC hDC; 
    XFORM xForm, xForm1, xForm2; 
    RECT rect; 
 
    // Retrieve a DC handle for the application's window. 
 
    hDC = GetWindowDC(hWnd); 
 
    // Set the mapping mode to LOENGLISH. This moves the 
    // client area origin from the upper left corner of the 
    // window to the lower left corner (this also reorients 
    // the y-axis so that drawing operations occur in a true 
    // Cartesian space). It guarantees portability so that 
    // the object drawn retains its dimensions on any display. 

    SetGraphicsMode(hDC, GM_ADVANCED);
    SetMapMode(hDC, MM_LOENGLISH); 
 
	doTransform(ROTATE, xForm1);
	doTransform(REFLECT, xForm2);
	CombineTransform(&xForm, &xForm1, &xForm2);
	SetWorldTransform(hDC, &xForm); 
    // Set the appropriate world transformation (based on the 
    // user's menu selection). 
 
 
    // Find the midpoint of the client area. 
 
    GetClientRect(hWnd, (LPRECT) &rect); 
    DPtoLP(hDC, (LPPOINT) &rect, 2); 
 
    // Select a hollow brush. 
 
    SelectObject(hDC, GetStockObject(HOLLOW_BRUSH)); 
 
    // Draw the exterior circle. 
 
    Ellipse(hDC, (rect.right / 2 - 100), (rect.bottom / 2 + 100), 
        (rect.right / 2 + 100), (rect.bottom / 2 - 100)); 
 
    // Draw the interior circle. 
 
    Ellipse(hDC, (rect.right / 2 -94), (rect.bottom / 2 + 94), 
        (rect.right / 2 + 94), (rect.bottom / 2 - 94)); 
 
    // Draw the key. 
 
    Rectangle(hDC, (rect.right / 2 - 13), (rect.bottom / 2 + 113), 
        (rect.right / 2 + 13), (rect.bottom / 2 + 50)); 
    Rectangle(hDC, (rect.right / 2 - 13), (rect.bottom / 2 + 96), 
        (rect.right / 2 + 13), (rect.bottom / 2 + 50)); 
 
    // Draw the horizontal lines. 
 
    MoveToEx(hDC, (rect.right/2 - 150), (rect.bottom / 2 + 0), NULL); 
    LineTo(hDC, (rect.right / 2 - 16), (rect.bottom / 2 + 0)); 
 
    MoveToEx(hDC, (rect.right / 2 - 13), (rect.bottom / 2 + 0), NULL); 
    LineTo(hDC, (rect.right / 2 + 13), (rect.bottom / 2 + 0)); 
 
    MoveToEx(hDC, (rect.right / 2 + 16), (rect.bottom / 2 + 0), NULL); 
    LineTo(hDC, (rect.right / 2 + 150), (rect.bottom / 2 + 0)); 
 
    // Draw the vertical lines. 
 
    MoveToEx(hDC, (rect.right/2 + 0), (rect.bottom / 2 - 150), NULL); 
    LineTo(hDC, (rect.right / 2 + 0), (rect.bottom / 2 - 16)); 
 
    MoveToEx(hDC, (rect.right / 2 + 0), (rect.bottom / 2 - 13), NULL); 
    LineTo(hDC, (rect.right / 2 + 0), (rect.bottom / 2 + 13)); 
 
    MoveToEx(hDC, (rect.right / 2 + 0), (rect.bottom / 2 + 16), NULL); 
    LineTo(hDC, (rect.right / 2 + 0), (rect.bottom / 2 + 150)); 
 
    ReleaseDC(hWnd, hDC); 
} 


/*

long CALLBACK myTest(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static RECT rect;
	static POINT hex, coord, center, origin;
	XFORM xForm, xForm1, xForm2;
	int mode;
	HDC hdc;
	HPEN hPen;
	POINT points[4];
	switch (message)
	{
	case WM_CREATE:
		mySprite.init(hwnd, "archer.bmp");
		GetClientRect(hwnd, &rect);
		hex.x=hex.y=-1;
		
		break;

	case WM_RBUTTONDOWN:

		//transformAndDraw(NORMAL, hwnd);

	
		break;
	case WM_LBUTTONDOWN:
		//transformAndDraw(REFLECT, hwnd);
		
 
		// Set the mapping mode to LOENGLISH. This moves the 
		// client area origin from the upper left corner of the 
		// window to the lower left corner (this also reorients 
		// the y-axis so that drawing operations occur in a true 
		// Cartesian space). It guarantees portability so that 
		// the object drawn retains its dimensions on any display. 

		
		GetClientRect(hwnd, &rect);

		
		myHex.init(rect.right, rect.bottom, mySprite.bitmap.bmWidth/0.612/2);
		//myHex.hex2rect(hex, rect);
		doDrawHexagon(myHex.size, RGB(255, 0, 0));
		myBackGround.init(hwnd);
		myBackGround.saveBackGround(rect);
		
		clientAreaOrg(origin, hwnd);
	
		clientAreaOrg(origin, hwnd);
		SetWindowOrgEx(hdc, -origin.x, -origin.y, NULL); 
		GetClientRect(hwnd, &rect);
		myHex.init(rect.right, rect.bottom, mySprite.bitmap.bmWidth/0.612/2);
		doDrawHexagon(myHex.size, RGB(255, 0, 0));
		//myHex.hex2rect(hex, rect);
		//doDrawHexagon(myHex.size, RGB(255, 0, 0));
		/*
		hdc = GetWindowDC(hwnd); 
		hPen=CreatePen(PS_SOLID, 1, RGB(255, 32, 32));
		hPen=(HPEN)SelectObject(hdc, hPen);
		/*
		SetMapMode(hdc, MM_LOENGLISH); 
		GetClientRect(hwnd, &rect);
		DPtoLP(hdc, (LPPOINT) &rect, 2); 

		
		SetGraphicsMode(hdc, GM_ADVANCED);
		SetMapMode(hdc, MM_LOENGLISH); 
 
		doTransform(ROTATE, xForm);
		//doTransform(REFLECT, xForm2);
		//CombineTransform(&xForm, &xForm1, &xForm2);
		SetWorldTransform(hdc, &xForm); 
		
		hPen=CreatePen(PS_SOLID, 5, RGB(255, 32, 32));
		hPen=(HPEN)SelectObject(hdc, hPen);
		//MoveToEx(hdc, origin.x, origin.y, NULL);
		MoveToEx(hdc, 100, 100, NULL);
		//LineTo(hdc, rect.right+origin.x, rect.bottom+origin.y);
		LineTo(hdc, 100, 400);

		Ellipse(hdc, (rect.right / 2 - 100), (rect.bottom / 2 + 100), 
        (rect.right / 2 + 100), (rect.bottom / 2 - 100)); 

		*/

		//SetWindowOrgEx(hdc, -origin.x, -origin.y, NULL);


		//SetWindowExtEx(hdc, 100, 100, NULL); 
		
/*
		points[0].x=points[0].y=0;
		points[1].x=400;
		points[1].y=0;
		points[2].x=400;
		points[2].y=400;
		points[3].x=points[3].y=0;
		Polyline(hdc, points, 4);

		hPen=(HPEN)SelectObject(hdc, hPen);
		DeleteObject(hPen);
		ReleaseDC(hwnd, hdc);
	

		break;
	}
	return 0L;
}
*/

BOOL __stdcall myProc(HDC hdc, LPARAM lParam, WPARAM wParam, int i, int j)
{
	return 0L;
}


BOOL CALLBACK OutputProc(
  HDC hdc,        // handle to DC
  LPARAM lpData,  // string
  int cchData     // length of string
)
{
	char* ptr=(char*)lpData;
	for (int i=0; i<cchData; i++)
	{
		//(*ptr)++;
	}
	return 1;
}

HDC hdc;
int count=0;

void myPrintMethod(char*msg)
{
	TextOut(hdc, 0, count*20, msg, strlen(msg));
	count++;
}

void drawGradient(HDC hdc)
{
	TRIVERTEX        vert [4] ;
	GRADIENT_TRIANGLE    gTri[2];
	GRADIENT_RECT    gRect;

	POINT origin;

	clientAreaOrg(origin);
	vert [0] .x       =  0;
	vert [0] .y       =  0;
	vert [0] .Red     =  0x0000;
	vert [0] .Green   =  0x0000;
	vert [0] .Blue    =  0x0000;
	vert [0] .Alpha   =  0x0000;

	vert [1] .x       =  100;
	vert [1] .y       =  0;
	vert [1] .Red     =  0x0000;
	vert [1] .Green   =  0x0000;
	vert [1] .Blue    =  0xff00;
	vert [1] .Alpha   =  0x0000;

	vert [2] .x       =  100;
	vert [2] .y       =  32; 
	vert [2] .Red     =  0x0000;
	vert [2] .Green   =  0x0000;
	vert [2] .Blue    =  0xff00;
	vert [2] .Alpha   =  0x0000;

	vert [3] .x       =  0;
	vert [3] .y       =  32;
	vert [3] .Red     =  0xff00;
	vert [3] .Green   =  0xff00;
	vert [3] .Blue    =  0xff00;
	vert [3] .Alpha   =  0x0000;

	gTri[0].Vertex1   = 0;
	gTri[0].Vertex2   = 1;
	gTri[0].Vertex3   = 2;

	gTri[1].Vertex1   = 0;
	gTri[1].Vertex2   = 2;
	gTri[1].Vertex3   = 3;
	GradientFill(hdc,vert,4,&gTri,2,GRADIENT_FILL_TRIANGLE);
	SetWindowOrgEx(hdc, origin.x, origin.y, &origin);



	SetWindowOrgEx(hdc, -400, -400, NULL);
	
	vert [0] .x      = 0;
	vert [0] .y      = 0;
	vert [0] .Red    = 0x0000;
	vert [0] .Green  = 0x0000;
	vert [0] .Blue   = 0x0000;
	vert [0] .Alpha  = 0x0000;

	vert [1] .x      = 100;
	vert [1] .y      = 200; 
	vert [1] .Red    = 0x0000;
	vert [1] .Green  = 0x0000;
	vert [1] .Blue   = 0xff00;
	vert [1] .Alpha  = 0x0000;

	gRect.UpperLeft  = 0;
	gRect.LowerRight = 1;
	GradientFill(hdc,vert,2,&gRect,1,GRADIENT_FILL_RECT_H);
}


void bitmapFan(HWND hwnd, POINT coord, HBITMAP hBitmap)
{
	XFORM xForm, xForm1, xForm2;
	BITMAP bitmap;
	HDC hdc, hTempDC;
	POINT origin;
	hdc=GetWindowDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);
	SelectObject(hTempDC, hBitmap);
	clientAreaOrg(origin, hwnd);
	coord.x+=origin.x;
	coord.y+=origin.y;

	SetGraphicsMode(hdc, GM_ADVANCED);

	GetObject(hBitmap, sizeof(BITMAP), &bitmap);

	for (int i=0; i<bitmap.bmWidth; i++)
	{
		translate(coord.x, coord.y, xForm1);
		rotate(i, xForm2);
		CombineTransform(&xForm, &xForm2, &xForm1);
		SetWorldTransform(hdc, &xForm);
		BitBlt(hdc, 0, 0, 1, bitmap.bmHeight, hTempDC, i, 0, SRCCOPY);
	}

	identity(xForm);
	SetWorldTransform(hdc, &xForm);

	BitBlt(hdc, origin.x, origin.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);

	
	DeleteDC(hTempDC);
	ReleaseDC(hwnd, hdc);
}

void motionBlur(HWND hwnd, POINT coord, HBITMAP hBitmap)
{
	XFORM xForm, xForm1, xForm2;
	BLENDFUNCTION myBlendFunc;
	int result, srcW, destW, number;
	BITMAP bitmap;
	//HBRUSH hBrush;
	HDC hdc, hTempDC;
	POINT origin;
	hdc=GetWindowDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);
	SelectObject(hTempDC, hBitmap);

	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	clientAreaOrg(origin, hwnd);
	coord.x+=origin.x;
	coord.y+=origin.y;
	//hBrush=(HBRUSH)SelectObject(hdc, (HBRUSH)GetStockObject(BLACK_BRUSH));
	//PatBlt(hdc, coord.x, coord.y, bitmap.bmWidth, bitmap.bmHeight, PATCOPY);

	SetGraphicsMode(hdc, GM_ADVANCED);

	myBlendFunc.BlendFlags=0;
	myBlendFunc.BlendOp=AC_SRC_OVER;
	myBlendFunc.AlphaFormat=0;
	translate(coord.x, coord.y, xForm);		
	SetWorldTransform(hdc, &xForm);

	
	number=10;
	int startAlpha=255;

	
	for (int i=0; i<number; i++)
	{		
		myBlendFunc.SourceConstantAlpha=startAlpha-i*startAlpha/number;		
		result=AlphaBlend(hdc, i*2, 0, bitmap.bmWidth, bitmap.bmHeight, 
			hTempDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, myBlendFunc);
	}

	identity(xForm);
	SetWorldTransform(hdc, &xForm);

	BitBlt(hdc, origin.x, origin.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);

	//SelectObject(hdc, hBrush);
	DeleteDC(hTempDC);
	ReleaseDC(hwnd, hdc);
}




void bitmapSpiral(HWND hwnd, POINT coord, HBITMAP hBitmap)
{
	XFORM xForm, xForm1, xForm2;
	BITMAP bitmap;
	HDC hdc, hTempDC;
	POINT origin;
	hdc=GetWindowDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);
	SelectObject(hTempDC, hBitmap);
	clientAreaOrg(origin, hwnd);
	coord.x+=origin.x;
	coord.y+=origin.y;

	SetGraphicsMode(hdc, GM_ADVANCED);

	GetObject(hBitmap, sizeof(BITMAP), &bitmap);

	for (int i=0; i<bitmap.bmWidth; i++)
	{		
		translate(coord.x, coord.y, xForm1);
		rotate(i, xForm2);
		CombineTransform(&xForm, &xForm2, &xForm1);
		SetWorldTransform(hdc, &xForm);
		BitBlt(hdc, i, 0, 1, bitmap.bmHeight, hTempDC, i, 0, SRCCOPY);
	}

	identity(xForm);
	SetWorldTransform(hdc, &xForm);

	BitBlt(hdc, origin.x, origin.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);

	
	DeleteDC(hTempDC);
	ReleaseDC(hwnd, hdc);
}



void alphaBlendBitmap(HWND hwnd, HBITMAP hBitmap, POINT coord, unsigned char alpha)
{
	HDC hdc, hTempDC;
	BLENDFUNCTION myBlendFunc;
	BITMAP bitmap;
	int result;
	POINT origin;
	hdc=GetWindowDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);

	clientAreaOrg(origin, hwnd);
	

	coord.x+=origin.x;
	coord.y+=origin.y;

	//hImageBitmap=convertBM4Blending(hdc, hBitmap);

	//hImageBitmap=(HBITMAP)SelectObject(hdc, hImageBitmap);
	SelectObject(hTempDC, hBitmap);

	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	//result=BitBlt(hdc, coord.x, coord.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC,
	//	0, 0, SRCCOPY);
	myBlendFunc.BlendFlags=0;
	myBlendFunc.BlendOp=AC_SRC_OVER;
	myBlendFunc.SourceConstantAlpha=alpha;
	myBlendFunc.AlphaFormat=0;
	result=AlphaBlend(hdc, coord.x, coord.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC,
		0, 0, bitmap.bmWidth, bitmap.bmHeight, myBlendFunc);
	SelectObject(hTempDC, NULL);
	DeleteDC(hTempDC);
	
	ReleaseDC(hwnd, hdc);
}



void setupSpinBitmap(POINT coord)
{
	POINT origin;


	clientAreaOrg(origin);

	coord.x+=origin.x;
	coord.y+=origin.y;


}


BOOL DoClipPath(HWND hwnd,LPLOGFONT lplf, LPSTR lpsz, POINT coord) 
{ 
    LOGFONT lf;           // logical font structure 
    HFONT hfont;          // new logical font handle 
    HFONT hfontOld;       // original logical font handle 
    HDC hdc;              // display DC handle 
    //int nXStart, nYStart; // drawing coordinates 
    RECT rc;              // rectangle structure for painting window 
    SIZE sz;              // size structure that receives text extents 
    int nStrLen;          // length of the string 
    int i, result;                // loop counter 
	HBRUSH hBrush ;
 
    // Retrieve a cached DC for the window. 
 
    hdc = GetDC(hwnd); 
 
    // Erase the current window contents. 
 
    GetClientRect(hwnd, &rc); 
    FillRect(hdc, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH)); 
 
    // Use the specified font to create a logical font and select it 
    // into the DC. 
 
    hfont = CreateFontIndirect(lplf); 
    if (hfont == NULL) 
        return FALSE; 
    hfontOld = (HFONT)SelectObject(hdc, hfont); 
 
    // Create a clip path. 
 
    nStrLen = lstrlen(lpsz); 

    result=BeginPath(hdc); 
        result=TextOut(hdc, coord.x, coord.y, lpsz, nStrLen); 
	
    result=EndPath(hdc); 
    result=SelectClipPath(hdc, RGN_DIFF); 
	if (result==0)
	{
		errHandle("error");
	}
 
    // Retrieve the dimensions of the rectangle surrounding 
    // the text. 
 
    result=GetTextExtentPoint32(hdc, lpsz, nStrLen, &sz); 
 
    // Draw horizontal lines through the clip path. 
	/*
 
    for (i = coord.y + 1; i < (coord.y + sz.cy); i += 3) 
    { 
       MoveToEx(hdc, coord.x, i, (LPPOINT) NULL); 
       LineTo(hdc, (coord.x + sz.cx), i); 
    } 
 
    // Draw vertical lines through the clip path. 
 
    for (i = coord.x + 1; i < (coord.x + sz.cx); i += 3)
    { 
       MoveToEx(hdc, i, coord.y, (LPPOINT) NULL); 
       LineTo(hdc, i, (coord.y + sz.cy)); 
    } 
	*/
	hBrush=CreateSolidBrush(RGB(255,0,0));
	hBrush=(HBRUSH)SelectObject(hdc, hBrush);
	BitBlt(hdc, coord.x, coord.y, sz.cx, sz.cy, hdc, sz.cx, sz.cy, PATCOPY);

	hBrush=(HBRUSH)SelectObject(hdc, hBrush);
	DeleteObject(hBrush);

 
    // Select the original font into the DC and release the DC. 
 
    SelectObject(hdc, hfontOld); 
    DeleteObject(hfont); 
    ReleaseDC(hwnd, hdc); 
 
    return TRUE; 
} 


void clipTest(HWND hwnd, POINT coord)
{
	static RECT rect, region;
	static POINT hex, center, origin;
	static XFORM xForm, xForm1, xForm2, xForm3;
	int mode, result, i, j;
	HDC hdc, hTempDC;
	HBRUSH hBrush, hRedBrush, hGreenBrush, hBlueBrush;
	HPEN hPen;
	COLORREF color;
	HBITMAP hBitmap=NULL, hOldBitmap;
	BITMAP bitmap;
	char msg[256];
	float radiant;
	char* str="this is ok";
	int counter, size;
	HRGN hRgn, hResultRgn, rectRgn, hRndRgn, hRgn1, hRgn2;
	RGNDATA rgnData;
	RGNDATAHEADER* rgnHeader;
	char* buf;
	static HMENU hMenu, hPopupMenu;

	hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
		LR_LOADFROMFILE);


	GetWindowRect(hwnd, &rect);
	hRndRgn=CreateRoundRectRgn(rect.left, rect.top, rect.right, rect.bottom,
		30, 100);
	//SetWindowRgn(hwnd, hRndRgn, TRUE);
		
	hdc=GetDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);
	SelectObject(hTempDC, hBitmap);

	GetObject(hBitmap, sizeof(BITMAP), &bitmap);

	
	SetGraphicsMode(hdc, GM_ADVANCED);
	translate(coord.x, coord.y, xForm1);
	rotate(60, xForm2);
	//scale(3, 3, xForm2);
	CombineTransform(&xForm, &xForm2, &xForm1);
	
	hRgn=CreateEllipticRgn(0, 0, bitmap.bmWidth,
		bitmap.bmHeight/2);
	

	size=GetRegionData(hRgn, 0, NULL);
	if (size!=0)
	{
		buf=new char[size];
		rgnHeader=(RGNDATAHEADER*)buf;
		rgnHeader->dwSize=sizeof(RGNDATAHEADER);
		rgnHeader->iType=RDH_RECTANGLES;
		rgnHeader->nCount=0;
		rgnHeader->nRgnSize=0;			
		
		if (GetRegionData(hRgn, size, (RGNDATA*)buf)==0)
		{
			errHandle("what");
		}
		if (rgnHeader->iType!=RDH_RECTANGLES)
		{
			errHandle("what ");
		}
		sprintf(msg, "ncount[%d]nRgnsize[%d]rcround[%d,%d,%d,%d]", rgnHeader->nCount,
			rgnHeader->nRgnSize, rgnHeader->rcBound.left, rgnHeader->rcBound.top,
			rgnHeader->rcBound.right, rgnHeader->rcBound.bottom);
		//SetWindowText(hwnd, msg);
	}
	else
	{
		errHandle("error");
	}

	hResultRgn=ExtCreateRegion(&xForm, size, (RGNDATA*)buf);

	
	hRedBrush=CreateSolidBrush(RGB(255,0,0));
	hGreenBrush=CreateSolidBrush(RGB(0,255,0));
	hBlueBrush=CreateSolidBrush(RGB(0,0,255));

	hRgn1=CreateRectRgn(0,0,0,0);

	//DeleteObject(hBrush);

	CombineRgn(hRgn1, hResultRgn, hRgn, RGN_OR);
	//translate(coord.x, coord.y, xForm);
	//SetWorldTransform(hdc, &xForm);
	FillRgn(hdc, hRgn, hRedBrush);



	translate(50, 50, xForm);
	SetWorldTransform(hdc, &xForm);
	FillRgn(hdc, hRgn1, hGreenBrush);



	translate(100, 100, xForm);
	SetWorldTransform(hdc, &xForm);
	FillRgn(hdc, hResultRgn, hBlueBrush);

	identity(xForm);
	SetWorldTransform(hdc, &xForm);

	//result=ExtSelectClipRgn(hdc, hResultRgn, RGN_COPY);
	switch (result)
	{
	case COMPLEXREGION:
		sprintf(msg, "comp");
		;
		break;
	case NULLREGION:
		sprintf(msg, "null");
		;
		break;
	case SIMPLEREGION:
		sprintf(msg, "simple");
		;
		break;
	case ERROR:
		sprintf(msg, "error");
		;
		break;
	}
	
	
	GetRgnBox(hResultRgn, &rect);
	hRgn2=CreateRectRgnIndirect(&rect);
	//result=ExtSelectClipRgn(hdc, hRgn2, RGN_XOR);
	switch (result)
	{
	case COMPLEXREGION:
		sprintf(msg+strlen(msg), "comp");
		;
		break;
	case NULLREGION:
		sprintf(msg+strlen(msg), "null");
		;
		break;
	case SIMPLEREGION:
		sprintf(msg+strlen(msg), "simple");
		;
		break;
	case ERROR:
		sprintf(msg+strlen(msg), "error");
		;
		break;
	}
	SetWindowText(hwnd, msg);

	//identity(xForm);
	//SetWorldTransform(hdc, &xForm);
	GetClientRect(hwnd, &region);
	hRgn2=CreateRectRgn(0,0,0,0);
	if (GetMetaRgn(hdc, hRgn2)==0)
	{
		errHandle("what");
	}
	GetRgnBox(hRgn2, &region);
	hBrush=CreateSolidBrush(RGB(128,128,128));
	FillRect(hdc, &region, hBrush);
	sprintf(msg, "[%d,%d,%d,%d]", region.left, region.top, region.right, region.bottom);
	SetWindowText(hwnd, msg);
	//FillRgn(hdc, hRgn2, hBrush);
	DeleteObject(hBrush);
	

	DeleteObject(hRedBrush);
	DeleteObject(hGreenBrush);
	DeleteObject(hBlueBrush);
	
	DeleteObject(hRgn1);
	DeleteObject(hRgn2);
	DeleteObject(hBitmap);
	DeleteDC(hTempDC);
	DeleteObject(hRgn);
	DeleteObject(rectRgn);
	DeleteObject(hResultRgn);
	delete[]buf;
	ReleaseDC(hwnd, hdc);

}
LOGFONT lf; 

PLOGFONT FAR PASCAL MyCreateFont( void ) 
{ 
    CHOOSEFONT cf; 
    
 
    // Initialize members of the CHOOSEFONT structure. 
 
    cf.lStructSize = sizeof(CHOOSEFONT); 
    cf.hwndOwner = (HWND)NULL; 
    cf.hDC = (HDC)NULL; 
    cf.lpLogFont = &lf; 
    cf.iPointSize = 0; 
    cf.Flags = CF_SCREENFONTS; 
    cf.rgbColors = RGB(0,0,0); 
    cf.lCustData = 0L; 
    cf.lpfnHook = (LPCFHOOKPROC)NULL; 
    cf.lpTemplateName = (LPSTR)NULL; 
    cf.hInstance = (HINSTANCE) NULL; 
    cf.lpszStyle = (LPSTR)NULL; 
    cf.nFontType = SCREEN_FONTTYPE; 
    cf.nSizeMin = 0; 
    cf.nSizeMax = 0; 
 
    // Display the CHOOSEFONT common-dialog box. 
 
    ChooseFont(&cf); 
 
    // Create a logical font based on the user's 
    // selection and return a handle identifying 
    // that font. 
 
    return cf.lpLogFont; 
    
} 


void drawRipple(char* imageName, HWND hwnd, LPARAM lParam)
{
	RECT rect, region;
	POINT hex, coord, center, origin;
	XFORM xForm, xForm1, xForm2, xForm3;
	int mode, result, i=0, j;
	HDC hdc, hTempDC;
	HBRUSH hBrush, hRedBrush, hGreenBrush, hBlueBrush;
	HPEN hPen;
	COLORREF color;
	HBITMAP hBitmap=NULL, hOldBitmap;
	BITMAP bitmap;
	char msg[256];
	float radiant;
	char* str="this is ok";
	int counter, size;
	HRGN hRgn, hResultRgn, hRectRgn, hRndRgn, hRgn1, hRgn2;
	HRGN hOutRgn, hInRgn;
	RGNDATA rgnData;
	RGNDATAHEADER* rgnHeader;
	char* buf;
	static HMENU hMenu, hPopupMenu;

	HFONT hFont;
	PLOGFONT pLogFont;
	POINT points[7];
	float factor;
	const int StartingAngle=10;
	const int AngleOffset=2;
	const int StartingSize=0;

	hBitmap=(HBITMAP)LoadImage(NULL, "newgirl.bmp", IMAGE_BITMAP, 0, 0, 
		LR_LOADFROMFILE);
	
	hdc=GetDC(hwnd);
	hTempDC=CreateCompatibleDC(hdc);
	//hBitmap=CreateCompatibleBitmap(hTempDC);


	//hBitmap=(HBITMAP)SelectObject(hTempDC, hBitmap);
	hBrush=CreatePatternBrush(hBitmap);
	//hBrush=(HBRUSH)SelectObject(hdc, hBrush);
	SelectObject(hTempDC, hBitmap);
	//hRgn1=CreateEllipticRgn(-100, -100, 100, 100);
	//hRgn2=CreateEllipticRgn(-102,-102, 102, 102);
	//CombineRgn(hRgn2, hRgn2, hRgn1, RGN_DIFF);
	//FillRgn(hdc, hRgn2, hBrush);

	
	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	hRedBrush=CreateSolidBrush(RGB(255,0,0));
	hGreenBrush=CreateSolidBrush(RGB(0,255,0));
	hBlueBrush=CreateSolidBrush(RGB(0,0,255));

	coord.x=LOWORD(lParam);
	coord.y=HIWORD(lParam);	
	
	
	hRgn=NULL;
	hRectRgn=CreateRectRgn(-bitmap.bmWidth/2, -bitmap.bmHeight/2, 
		bitmap.bmWidth/2, bitmap.bmHeight/2);

	//hRectRgn=CreateRectRgn(-bitmap.bmWidth, -bitmap.bmHeight, 
	//	bitmap.bmWidth, bitmap.bmHeight);
	//FillRgn(hdc, hRectRgn, hBrush);
	SetGraphicsMode(hdc, GM_ADVANCED);
	translate(coord.x, coord.y, xForm1);

	
	for (i=1; i<bitmap.bmWidth/2; i++)
	//for (i=0; i<90; i++)
	{
		DeleteObject(hRgn);
		hRgn=CreateEllipticRgn(-i, -i, i, i);
		GetRgnBox(hRgn, &rect);
		CombineRgn(hRgn, hRectRgn, hRgn, RGN_DIFF);

		GetRgnBox(hRgn, &rect);
		//translate(coord.x+i*5, coord.y+i*5, xForm1);
		factor=DEG2RAD((i*AngleOffset+StartingAngle)%20);
		//factor=DEG2RAD(i);
		factor=1+1.5*sinf(factor);
	
		scale(factor, factor, xForm2);
		CombineTransform(&xForm, &xForm2, &xForm1);
		SetWorldTransform(hdc, &xForm);

		OffsetRgn(hRgn, coord.x, coord.y);
		
		result=SelectClipRgn(hdc, hRgn);
		switch (result)
		{
		case COMPLEXREGION:
			sprintf(msg, "comp");
			;
			break;
		case NULLREGION:
			sprintf(msg, "null");
			;
			break;
		case SIMPLEREGION:
			sprintf(msg, "simple");
			;
			break;
		case ERROR:
			sprintf(msg, "error");
			;
			break;
		}
		GetRgnBox(hRgn, &rect);
		sprintf(msg+strlen(msg), "[%d,%d,%d,%d]", rect.left, rect.top, 
			rect.right, rect.bottom);
		SetWindowText(hwnd, msg);

		BitBlt(hdc, -bitmap.bmWidth/2, -bitmap.bmHeight/2, bitmap.bmWidth, 
			bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);
		//FillRgn(hdc, hRgn, hBrush);
	}
	SelectClipRgn(hdc, NULL);
	identity(xForm);
	SetWorldTransform(hdc, &xForm);


	DeleteObject(hRectRgn);
	DeleteObject(hRgn);
	DeleteObject(hResultRgn);
	DeleteObject(hBrush);
	DeleteObject(hRedBrush);
	DeleteObject(hBlueBrush);
	DeleteObject(hGreenBrush);
	ReleaseDC(hwnd, hdc);
	DeleteObject(hBitmap);
}

int left=20;
int top=50;
int right=100;
int bottom=150;

void myDraw(HDC hdc, POINT coord)
{
	RECT rect;
	POINT* points;
	BYTE* ops;
	MoveToEx(hdc, coord.x, coord.y, NULL);
	AngleArc(hdc, coord.x, coord.y, 100, 0, 90);
	

	MoveToEx(hdc, coord.x, coord.y,  NULL);
	
	Pie(hdc, 0, 0, 250, 250, left, top, right, bottom);
	//PolyDraw(hdc, points, ops, 6);

	//Chord(hdc, 400, 400, 600, 650, 150, 20, 100, 80);
}


void magnifier(HWND hwnd, POINT coord, int radius, float ratio)
{
	HRGN hRgn, hClipRgn;
	HBITMAP hBitmap;
	HDC hMemDC, hdc;
	int result;
	//int width, height;
	XFORM xForm, xForm1, xForm2;

	HBRUSH hRedBrush, hBlueBrush;
	hdc=GetDC(hwnd);
	hRedBrush=CreateSolidBrush(RGB(255, 0, 0));
	hBlueBrush=CreateSolidBrush(RGB(0, 0, 255));
	hClipRgn=CreateRectRgn(0,0,0,0);
	hRgn=CreateEllipticRgn(coord.x-radius, coord.y-radius, coord.x+radius, coord.y+radius);
	
	
	result=GetClipRgn(hdc, hClipRgn);
	if (result==1)
	{
		//FillRgn(hdc, hClipRgn, hRedBrush);
	}

	ExtSelectClipRgn(hdc, hRgn, RGN_COPY);
	result=GetClipRgn(hdc, hClipRgn);
	if (result==1)
	{
		//FillRgn(hdc, hClipRgn, hBlueBrush);
	}
	//width=2*radius/ratio;
	//height=2*radius/ratio;
	hBitmap=CreateCompatibleBitmap(hdc, 2*radius, 2*radius);
	hMemDC=CreateCompatibleDC(hdc);
	SelectObject(hMemDC, hBitmap);
	BitBlt(hMemDC, 0, 0, radius*2, radius*2, hdc, coord.x-radius, coord.y-radius, SRCCOPY);
	
	//

	scale(ratio, ratio, xForm1);
	translate(coord.x, coord.y, xForm2);
	CombineTransform(&xForm, &xForm1, &xForm2);
	SetGraphicsMode(hdc, GM_ADVANCED);
	

	result=GetClipRgn(hdc, hClipRgn);
	if (result==1)
	{
		FillRgn(hdc, hClipRgn, hBlueBrush);
	}
	SetWorldTransform(hdc, &xForm);
	BitBlt(hdc, -radius, -radius, radius*2, radius*2, 
		hMemDC, 0, 0, SRCCOPY);
	identity(xForm);
	SetWorldTransform(hdc, &xForm);
	DeleteDC(hMemDC);
	DeleteObject(hBitmap);
	DeleteObject(hRgn);
}




HRGN pathTest(HDC hdc, POINT coord)
{
	POINT p1, p2, p3, p4;
	p1.x=coord.x+400;
	p1.y=coord.y;
	p2.x=coord.x;
	p2.y=coord.y+400;
	p3.x=coord.x+400/2;
	p3.y=coord.y+400/2;


	MoveToEx(hdc, coord.x, coord.y, NULL);
	LineTo(hdc, p1.x, p1.y);
	MoveToEx(hdc, coord.x, coord.y, NULL);
	LineTo(hdc, p2.x, p2.y);
	MoveToEx(hdc, p1.x, p1.y, NULL);
	LineTo(hdc, p3.x, p3.y);
	MoveToEx(hdc, p2.x, p2.y, NULL);
	LineTo(hdc, p3.x, p3.y);

	BeginPath(hdc);
	MoveToEx(hdc, coord.x, coord.y, NULL);
	LineTo(hdc, p1.x, p1.y);
	//MoveToEx(hdc, coord.x, coord.y, NULL);
	//LineTo(hdc, p2.x, p2.y);
	//MoveToEx(hdc, p1.x, p1.y, NULL);
	LineTo(hdc, p3.x, p3.y);
	//MoveToEx(hdc, p2.x, p2.y, NULL);
	//LineTo(hdc, p3.x, p3.y);
	LineTo(hdc, p2.x, p2.y);
	EndPath(hdc);
	return PathToRegion(hdc);
}


POINT points[123]=
{
	{0,321},{1,321},{2,321},{3,321},{4,321},{5,321},{6,321},{7,321},{8,321},{9,321},{10,321},{11,321},{12,321},{13,321},{14,321},{15,321},{16,321},{17,321},{18,321},{19,321},{20,321},{21,321},{22,321},{23,321},{24,321},{25,321},{26,321},{27,321},{28,321},{29,321},{30,321},{31,321},{31,320},{31,319},{31,318},{31,317},{31,316},{31,315},{31,314},{31,313},{31,312},{31,311},{31,310},{31,309},{31,308},{31,307},{31,306},{31,305},{31,304},{31,303},{31,302},{31,301},{31,300},{30,300},{29,300},{28,299},{28,298},{27,298},{26,297},{25,296},{24,295},{24,294},{24,293},{23,292},{23,291},{23,290},{22,290},{21,289},{20,289},{19,289},{18,289},{17,288},{16,288},{15,287},{14,287},{13,287},{12,287},{11,287},{10,287},{9,287},{8,287},{7,287},{6,287},{5,287},{4,287},{3,287},{2,287},{1,287},{0,287},{0,288},{0,289},{0,290},{0,291},{0,292},{0,293},{0,294},{0,295},{0,296},{0,297},{0,298},{0,299},{0,300},{0,301},{0,302},{0,303},{0,304},{0,305},{0,306},{0,307},{0,308},{0,309},{0,310},{0,311},{0,312},{0,313},{0,314},{0,315},{0,316},{0,317},{0,318},{0,319},{0,320},{0,321}
};

BoolCombination bCom;

RGBTRIPLE redColor={0,0,255}, blueColor={255,0,0}, greenColor={0,255,0};


void setImageByPattern(RGBTRIPLE* pImage, bool* pattern)
{
	long i, x, y;
	for (i=0; i<8; i++)
	{
		x=y=1;
		gridOp(x, y, i);
		if (pattern[i])
		{
			memcpy(pImage+y*3+x, &redColor, sizeof(RGBTRIPLE));
		}
		else
		{
			memcpy(pImage+y*3+x, &blueColor, sizeof(RGBTRIPLE));
		}
	}
	memcpy(pImage+4, &greenColor, sizeof(RGBTRIPLE));
}

RGBTRIPLE* createPattern()
{	
	bool* pChoices;
	RGBTRIPLE* pImage;
	
/*
	redColor.rgbtRed=255;
	redColor.rgbtBlue=redColor.rgbtGreen=0;
	blueColor.rgbtBlue=255;
	blueColor.rgbtGreen=blueColor.rgbtRed=0;
	greenColor.rgbtGreen=255;
	greenColor.rgbtBlue=greenColor.rgbtRed=0;
*/
	bool choices[2]={true, false};
	pChoices=bCom.init(8, choices, 2);
	pImage=new RGBTRIPLE[9];
	setImageByPattern(pImage, pChoices);

	return pImage;
}


void drawPattern(HDC hdc, POINT coord, RGBTRIPLE* pImage)
{
	for (int y=0; y<3; y++)
	{
		for (int x=0; x<3; x++)
		{
			SetPixel(hdc, coord.x+x, coord.y+y, RGB(pImage[y*3+x].rgbtRed, 
				pImage[y*3+x].rgbtGreen, pImage[y*3+x].rgbtBlue));
		}
	}
}	

HBRUSH hRedBrush, hBlueBrush, hGreenBrush;


void drawPattern(HDC hdc, POINT coord, bool* pattern)
{
	RECT rect;
	const unsigned int RectSize=30;
	long i, x, y;

	for (i=0; i<8; i++)
	{
		x=y=1;
		gridOp(x, y, i);
		rect.left=coord.x+RectSize*x;
		rect.top=coord.y+RectSize*y;
		rect.right=rect.left+RectSize;
		rect.bottom=rect.top+RectSize;

		if (pattern[i])
		{
			FillRect(hdc, &rect, hRedBrush);
		}
		else
		{
			FillRect(hdc, &rect, hBlueBrush);
		}
	}
	rect.left=coord.x+RectSize;
	rect.top=coord.y+RectSize;
	rect.right=rect.left+RectSize;
	rect.bottom=rect.top+RectSize;
	FillRect(hdc, &rect, hGreenBrush);

}

		
		
/*
long CALLBACK myTest(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int i;
	bool* pPattern;
	static int counter=0;
	static POINT coord;
	HDC hdc, hMemDC;
	BITMAP bitmap;
	BITMAPINFO bmInfo;
	static RgnVector rgnVector;
	static RGBTRIPLE* pImage=NULL;
	RECT rect;
	char msg[128];
	HRGN hRgn, hRectRgn;
	HBRUSH hBrush;
	HPEN hRedPen, hGreenPen;
	XFORM xForm;
	bool choices[2]={true, false};

	static TCHAR pstrFileName[MAX_PATH], pstrTitleName[MAX_PATH];
	switch (message)
	{
	case WM_CREATE:
		hRedBrush=CreateSolidBrush(RGB(255,0,0));
		hBlueBrush=CreateSolidBrush(RGB(0,0,255));
		hGreenBrush=CreateSolidBrush(RGB(0,255,0));
		break;
	case WM_LBUTTONDOWN:
		
		//pImage=createPattern();
		hdc=GetDC(hwnd);		

		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		
		pPattern=bCom.init(8, choices, 2);
		drawPattern(hdc, coord, pPattern);
		ReleaseDC(hwnd, hdc);	
		
			
		
		break;
	case WM_RBUTTONDOWN:
		
		hdc=GetDC(hwnd);		
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		pPattern=bCom.nextCombination();		
		drawPattern(hdc, coord, pPattern);
		ReleaseDC(hwnd, hdc);	

		break;		
	}

	return 0L;
}
*/
	

long CALLBACK myTest(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int i;
	bool* pPattern;
	static int counter=0;
	static POINT coord;
	HDC hdc, hMemDC;
	BITMAP bitmap;
	BITMAPINFO bmInfo;
	static RgnVector rgnVector;
	static RGBTRIPLE* pImage=NULL;
	RECT rect;
	char msg[128];
	HRGN hRgn, hRectRgn;
	HBRUSH hBrush;
	HPEN hRedPen, hGreenPen;
	XFORM xForm, xForm1, xForm2, xForm3;
	bool choices[2]={true, false};


	static TCHAR pstrFileName[MAX_PATH], pstrTitleName[MAX_PATH];

	switch (message)
	{
	case WM_CREATE:
		hRedBrush=CreateSolidBrush(RGB(255,0,0));
		hBlueBrush=CreateSolidBrush(RGB(0,0,255));
		hGreenBrush=CreateSolidBrush(RGB(0,255,0));
		break;
	case WM_LBUTTONDOWN:
		
		//pImage=createPattern();
		hdc=GetDC(hwnd);		

		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);

		hRgn=CreateRectRgn(coord.x, coord.y, coord.x+200, coord.y+200);
		//hRectRgn=CreateRectRgn(coord.x, coord.y, coord.x+300, coord.y+300);


		//CombineRgn(hRgn, hRgn, hRectRgn, RGN_DIFF);

		displayRgn(hdc, hRgn);
		translate(-coord.x, -coord.y, xForm1);

		rotate(40, xForm2);

		CombineTransform(&xForm3, &xForm1, &xForm2);

		translate(coord.x, coord.y, xForm1);

		CombineTransform(&xForm, &xForm3, &xForm1);

		hRectRgn=transformRegion(hRgn, &xForm);

		displayRgn(hdc, hRectRgn);
		sprintf(msg, "old area [%d], new area [%d]", getRegionArea(hRgn), 
			getRegionArea(hRectRgn));

		SetWindowText(hwnd, msg);

		DeleteObject(hRgn);
		DeleteObject(hRectRgn);
		
		
		ReleaseDC(hwnd, hdc);			
		break;
	case WM_RBUTTONDOWN:
		
		hdc=GetDC(hwnd);		
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		pPattern=bCom.nextCombination();		
		drawPattern(hdc, coord, pPattern);
		ReleaseDC(hwnd, hdc);	

		break;		
	}

	return 0L;
}
	

/*
	//if (!readImageInfoPNG(bitmapInfo, "myGirl.png"))
		{
		//	break;
		}
		
		fileHandle=CreateFile("xiangqi.png", GENERIC_READ, FILE_SHARE_READ,
			NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		size=GetFileSize(fileHandle, NULL);
		fileMapHandle=CreateFileMapping(fileHandle, NULL, PAGE_READONLY, 0, 0, NULL);
		ptr=(unsigned char*)MapViewOfFile(fileMapHandle, FILE_MAP_READ, 0, 0, 0);
	
		hdc=GetDC(hwnd);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		GetClientRect(hwnd, &rect);

		//result=ExtEscape(hdc, CHECKPNGFORMAT, size-33, const_cast<const char*>(ptr+33), 4, &ch);
		//errHandle("why");

		//hImageBitmap=(HBITMAP)LoadImage(NULL, "myGirl.bmp", IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		//GetObject(hImageBitmap, sizeof(BITMAP), &bitmap);
		

/*
		memset(&bm5Header, 0, sizeof(BITMAPV5HEADER));
		bm5Header.bV5Size=sizeof(BITMAPV5HEADER);
		bm5Header.bV5Width=380;
		bm5Header.bV5Height=380;
		bm5Header.bV5Planes=1;
		bm5Header.bV5BitCount=32;
		bm5Header.bV5Compression=BI_PNG;
		bm5Header.bV5SizeImage=size;
		bm5Header.bV5XPelsPerMeter=bm5Header.bV5YPelsPerMeter=0;
		bm5Header.bV5ClrImportant=bm5Header.bV5ClrUsed=0;
		bm5Header.bV5CSType=LCS_sRGB;
		memset(&bitmapInfo.bmiHeader, 0, sizeof(BITMAPINFOHEADER));

		bitmapInfo.bmiHeader.biCompression=BI_PNG;
		bitmapInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bitmapInfo.bmiHeader.biPlanes=1;
		bitmapInfo.bmiHeader.biSizeImage=0;
		bitmapInfo.bmiHeader.biHeight=380;
		bitmapInfo.bmiHeader.biWidth=380;
		bitmapInfo.bmiHeader.biBitCount=24;	
		

		memset(&bitmapInfo, 0, sizeof(BITMAPINFO));
		bitmapInfo.bmiHeader.biCompression=BI_PNG;
		bitmapInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bitmapInfo.bmiHeader.biPlanes=1;
		bitmapInfo.bmiHeader.biSizeImage=size;
		bitmapInfo.bmiHeader.biHeight=460;
		bitmapInfo.bmiHeader.biWidth=412;
		bitmapInfo.bmiHeader.biBitCount=8;
		bitmapInfo.bmiHeader.biYPelsPerMeter=bitmapInfo.bmiHeader.biXPelsPerMeter=1000;
		
		//ptr=readImagePNG(bitmapInfo, "xiangqi.png");
		//bitmapInfo.bmiHeader.biBitCount=0;	
		//result=SetDIBitsToDevice(hdc, 0, 0, 380, 380, 0, 380, 0, 380, ptr, 
		//	&bitmapInfo, DIB_RGB_COLORS);

		//ptr=new unsigned char[bitmap.bmWidth*bitmap.bmHeight*4];
		///result=GetDIBits(hdc, hImageBitmap, 0, bitmap.bmHeight, ptr, &bitmapInfo, 
		//	DIB_RGB_COLORS);
		ul = CHECKJPEGFORMAT; 

		result=ExtEscape(hdc, QUERYESCSUPPORT, sizeof(ul), (const char*)&ul, 0, 0) ;
		if (result<0)
		{
			errHandle("problem of extEscape");
		}

		result=StretchDIBits(hdc, 0, 0, bitmapInfo.bmiHeader.biWidth, 
			bitmapInfo.bmiHeader.biHeight, 0, bitmapInfo.bmiHeader.biHeight, 
			bitmapInfo.bmiHeader.biWidth, bitmapInfo.bmiHeader.biHeight, 
			ptr, &bitmapInfo, DIB_RGB_COLORS, SRCCOPY);

		if (result==GDI_ERROR)
		{
			errHandle("err");
		}
		//hBitmap=CreateDIBitmap(hdc, (BITMAPINFOHEADER*) &bm5Header, CBM_INIT, ptr, &bitmapInfo, DIB_RGB_COLORS);
/*
		memset(&bitmapInfo.bmiHeader, 0, sizeof(BITMAPINFOHEADER));

		bitmapInfo.bmiHeader.biCompression=BI_PNG;
		bitmapInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bitmapInfo.bmiHeader.biPlanes=1;
		bitmapInfo.bmiHeader.biSizeImage=size;
		bitmapInfo.bmiHeader.biHeight=380;
		bitmapInfo.bmiHeader.biWidth=380;
		bitmapInfo.bmiHeader.biBitCount=24;

		result=StretchDIBits(hdc, 0, 0, rect.right, rect.bottom, 0, 0, 380, 380, 
			ptr+33, &bitmapInfo, DIB_RGB_COLORS, SRCCOPY);
			
		if (hBitmap==NULL)
		{
			errHandle("err");
		}
		

		ReleaseDC(hwnd, hdc);

		//UnmapViewOfFile(ptr);
		CloseHandle(fileMapHandle);
		CloseHandle(fileHandle);
	
  	if (index==0)
		{
			myBackGround.init(hwnd, true);
			//GetClientRect(hwnd, &rect);
			//myBackGround.saveBackGround(rect);
			
		}
		if (index<256)
		{
			index++;
		}
		sprintf(msg, "%X", index);
		SetWindowText(hwnd, msg);
		
		hdc=GetDC(hwnd);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
	


		color=GetPixel(hdc, coord.x, coord.y);
		//hBitmap=CreateCompatibleBitmap(hdc, BitmapSize, BitmapSize);
		
		hBrush=CreateSolidBrush(color);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		BitBlt(hdc, coord.x, coord.y, BitmapSize, BitmapSize, hdc, 
			coord.x, coord.y, rasterOp[index]);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);

		DeleteObject(hBrush);
		ReleaseDC(hwnd, hdc);
	//if (!startDrawing)
		{
			//myPeekHole.init(coord, 50, 200);
			//startDrawing=true;	
		}
		else
		{
			//myFishEye.drawFishEye(hdc, coord, true);
		}
hdc=GetDC(hwnd);
		hBrush=CreateSolidBrush(RGB(255, 0, 0));
		result=BeginPath(hdc);
		//BitBlt(hdc, coord.x, coord.y, mySprite.bitmap.bmWidth, mySprite.bitmap.bmHeight,
		//	mySprite.hMaskDC, 0, 0, SRCCOPY);
		myDraw(hdc, coord);
		result=EndPath(hdc);

		StrokeAndFillPath(hdc);

		hRgn=PathToRegion(hdc);
		if (hRgn==NULL)
		{
			result=GetLastError();
			switch(result)
			{
			case  ERROR_CAN_NOT_COMPLETE:
				sprintf(msg, "ERROR_CAN_NOT_COMPLETE");
				break;
			case ERROR_INVALID_PARAMETER:
				sprintf(msg, "ERROR_INVALID_PARAMETER");
				break;
			case ERROR_NOT_ENOUGH_MEMORY:
				sprintf(msg, "ERROR_NOT_ENOUGH_MEMORY");
				break;
			}
			SetWindowText(hwnd, msg);
		}
		
		//FillRgn(hdc, hRgn, hBrush);

		rect.left=left;
		rect.top=top;
		rect.right=right;
		rect.bottom=bottom;
		//InvertRect(hdc, &rect);
	
		
		DeleteObject(hBrush);
		DeleteObject(hRgn);
		ReleaseDC(hwnd, hdc);

  */
/*
	if (hBitmap==NULL)
		{			
			hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
				LR_LOADFROMFILE);
			
			hdc=GetDC(hwnd);
			//hTempDC=CreateCompatibleDC(hdc);
			//hBitmap=CreateCompatibleBitmap(hTempDC);


			//hBitmap=(HBITMAP)SelectObject(hTempDC, hBitmap);
			hBrush=CreatePatternBrush(hBitmap);
			//hBrush=(HBRUSH)SelectObject(hdc, hBrush);
			//hRgn1=CreateEllipticRgn(-100, -100, 100, 100);
			//hRgn2=CreateEllipticRgn(-102,-102, 102, 102);
			//CombineRgn(hRgn2, hRgn2, hRgn1, RGN_DIFF);
			//FillRgn(hdc, hRgn2, hBrush);

			
			GetObject(hBitmap, sizeof(BITMAP), &bitmap);
			hRedBrush=CreateSolidBrush(RGB(255,0,0));
			hGreenBrush=CreateSolidBrush(RGB(0,255,0));
			hBlueBrush=CreateSolidBrush(RGB(0,0,255));

			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			buf=NULL;
			hRectRgn=CreateEllipticRgn(-StartingSize, -StartingSize, 
				StartingSize, StartingSize);
			//result=FillRgn(hdc, hRectRgn, hBrush);
		
			size=GetRegionData(hRectRgn, 0, NULL);
			hRgn=CreateRectRgn(0,0,0,0);
			if (size==0)
			{
				errHandle("region data");
			}
			delete[]buf;
			buf=new char[size];
			GetRegionData(hRectRgn, size, (LPRGNDATA)buf);
			
			SetGraphicsMode(hdc, GM_ADVANCED);
			translate(coord.x, coord.y, xForm1);
			//hOutRgn=CreateEllipticRgn(-StartingSize, -StartingSize,
			//	StartingSize, StartingSize);
			//hInRgn=CreateEllipticRgn(-StartingSize, -StartingSize, StartingSize, 
			//	StartingSize);		
			factor=DEG2RAD(i*AngleOffset+StartingAngle);
			factor=5*sinf(factor);
			scale(factor, factor, xForm2);
			CombineTransform(&xForm, &xForm2, &xForm1);

			hOutRgn=ExtCreateRegion(&xForm2, size, (LPRGNDATA)buf);

			hInRgn=ExtCreateRegion(&xForm2, size, (LPRGNDATA)buf);
			

			for (i=0; i<30; i++)
			{
				factor=DEG2RAD(i*AngleOffset+StartingAngle);
				factor=5*sinf(factor);
				scale(factor, factor, xForm2);
				CombineTransform(&xForm, &xForm2, &xForm1);
				SetWorldTransform(hdc, &xForm1);
			
				//DeleteObject(hInRgn);
				//hInRgn=hOutRgn;
				//FillRgn(hdc, hInRgn, hRedBrush);
				GetRgnBox(hInRgn, &rect);
				if (i%2==0)
				{
					DeleteObject(hOutRgn);
					hOutRgn=ExtCreateRegion(&xForm2, size, (LPRGNDATA)buf);
				//hOutRgn=ExtCreateRegion(NULL, size, (LPRGNDATA)buf);
				//result=FillRgn(hdc, hOutRgn, hGreenBrush);
					GetRgnBox(hOutRgn, &rect);
					CombineRgn(hRgn, hOutRgn, hInRgn, RGN_DIFF);
					result=FillRgn(hdc, hRgn, hBlueBrush);
				}
				else
				{
					DeleteObject(hInRgn);
					hInRgn=ExtCreateRegion(&xForm2, size, (LPRGNDATA)buf);
					GetRgnBox(hInRgn, &rect);
					CombineRgn(hRgn, hInRgn, hOutRgn, RGN_DIFF);
					result=FillRgn(hdc, hRgn, hGreenBrush);
				}
				
				//BitBlt(hdc, -bitmap.bmWidth/2, -bitmap.bmHeight/2, bitmap.bmWidth,
			

			}
			
			DeleteObject(hOutRgn);
			//DeleteObject(hRectRgn);
			DeleteObject(hInRgn);
			DeleteObject(hBrush);
			delete[]buf;
			ReleaseDC(hwnd, hdc);
			DeleteObject(hBitmap);
			*/
		
/*
	hPopupMenu=CreatePopupMenu();
		AppendMenu(hPopupMenu, MF_STRING, ID_MY_MENU_ITEM, "what");

		AppendMenu(hPopupMenu, MF_STRING, ID_MY_MENU_ITEM, "&File");
long CALLBACK myTest(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static RECT rect, region;
	static POINT hex, coord, center, origin;
	static XFORM xForm, xForm1, xForm2, xForm3;
	int mode, result, i, j;
	HDC hdc, hTempDC;
	HBRUSH hBrush;
	HPEN hPen;
	COLORREF color;
	HBITMAP hBitmap=NULL, hOldBitmap;
	BITMAP bitmap;
	char msg[256];
	float radiant;
	char* str="this is ok";
	static int counter;
	HRGN hRgn;

	OSVERSIONINFO versionInfo;
	switch (message)
	{
	case WM_CREATE:
		mySprite.init(hwnd, "archer.bmp");
		GetClientRect(hwnd, &rect);
		hex.x=hex.y=-1;
		
		break;
	case WM_TIMER:
		
		counter++;
		if (counter==250)
		{
			KillTimer(hwnd, 1);
		}
		
		//rotate(3*counter, xForm2);
		//reflect(-2.5, 1.0, xForm2);
		shear(-1, 1.0, xForm2);
		CombineTransform(&xForm, &xForm2, &xForm1);
		
		result=SetWorldTransform(hdc, &xForm);
		result=BitBlt(hdc, -bitmap.bmWidth/2, -bitmap.bmHeight/2, bitmap.bmWidth, bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);
	
		break;
	case WM_RBUTTONDOWN:
		if (hBitmap==NULL)
		{			
			hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
				LR_LOADFROMFILE);
			
			hdc=GetDC(hwnd);
			hTempDC=CreateCompatibleDC(hdc);
			//hBitmap=CreateCompatibleBitmap(hTempDC);


			hBitmap=(HBITMAP)SelectObject(hTempDC, hBitmap);

			GetObject(hBitmap, sizeof(BITMAP), &bitmap);

			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			counter=0;
			//SetGraphicsMode(hdc, GM_ADVANCED);
			//translate(coord.x, coord.y, xForm);
			//SetWorldTransform(hdc, &xForm);
			
			
			BitBlt(hdc, coord.x, coord.y,  bitmap.bmWidth,
					bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);
		
				
			//SetTimer(hwnd, 1, 10, NULL);	
			
		}
		else
		{					
			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			counter++;
		

			BitBlt(hdc, coord.x, coord.y,  bitmap.bmWidth,
					bitmap.bmHeight, hTempDC, bitmap.bmWidth/2, 0, SRCCOPY);
			
					
		}


		break;
	case WM_LBUTTONDOWN:
		hdc=GetDC(hwnd);
		//Chord(hdc, 0,0, 200, 200, 10, 10, 180,180);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);	
		hRgn=CreateEllipticRgn(coord.x, coord.y,  400, 380);
		if (!InvertRgn(hdc, hRgn))
		{
			errHandle("what");
		}
		ExtSelectClipRgn(hdc, hRgn, RGN_COPY);

		hTempDC=CreateCompatibleDC(hdc);
			//hBitmap=CreateCompatibleBitmap(hTempDC);


		hBitmap=(HBITMAP)SelectObject(hTempDC, hBitmap);

		GetObject(hBitmap, sizeof(BITMAP), &bitmap);

		hBrush=(HBRUSH)SelectObject(hdc, (HBRUSH)GetStockObject(WHITE_BRUSH));
		BitBlt(hdc, coord.x, coord.y,  bitmap.bmWidth,
					bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);

		SelectObject(hdc, hBrush);
		ReleaseDC(hwnd, hdc);
		DeleteObject(hRgn);
		DeleteObject(hBitmap);
		DeleteDC(hTempDC);
		break;

	case WM_NCCREATE:

		
		hRgn=CreateEllipticRgn(coord.x, coord.y,  400, 380);
		SetWindowRgn(hwnd, hRgn, FALSE);

		break;
	}
	return 0L;
}
	
*/
		/*


  	static RECT rect, region;
	static POINT hex, coord, center, origin;
	static XFORM xForm, xForm1, xForm2, xForm3;
	int mode, result, i, j;
	static HDC hdc, hTempDC;
	HBRUSH hBrush;
	HPEN hPen;
	COLORREF color;
	static HBITMAP hBitmap=NULL, hOldBitmap;
	static BITMAP bitmap;
	char msg[256];
	float radiant;
	char* str="this is ok";
	static int counter;

	OSVERSIONINFO versionInfo;
	switch (message)
	{
	case WM_CREATE:
		mySprite.init(hwnd, "archer.bmp");
		GetClientRect(hwnd, &rect);
		hex.x=hex.y=-1;
		
		break;
	case WM_TIMER:
		
		counter++;
		if (counter==250)
		{
			KillTimer(hwnd, 1);
		}
		
		//rotate(3*counter, xForm2);
		//reflect(-2.5, 1.0, xForm2);
		shear(-1, 1.0, xForm2);
		CombineTransform(&xForm, &xForm2, &xForm1);
		
		result=SetWorldTransform(hdc, &xForm);
		result=BitBlt(hdc, -bitmap.bmWidth/2, -bitmap.bmHeight/2, bitmap.bmWidth, bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);
	
		break;
	case WM_RBUTTONDOWN:
		if (hBitmap==NULL)
		{			
			hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
				LR_LOADFROMFILE);
			
			hdc=GetDC(hwnd);
			hTempDC=CreateCompatibleDC(hdc);
			SelectObject(hTempDC, hBitmap);

			GetObject(hBitmap, sizeof(BITMAP), &bitmap);

			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			counter=0;
			//SetGraphicsMode(hdc, GM_ADVANCED);
			//translate(coord.x, coord.y, xForm);
			//SetWorldTransform(hdc, &xForm);
			
			BitBlt(hdc, coord.x, coord.y,  bitmap.bmWidth,
					bitmap.bmHeight, hTempDC, 0, 0, SRCCOPY);
		
				
			//SetTimer(hwnd, 1, 10, NULL);	
			
		}
		else
		{					
			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			counter++;
		

			BitBlt(hdc, coord.x, coord.y,  bitmap.bmWidth,
					bitmap.bmHeight, hTempDC, bitmap.bmWidth/2, 0, SRCCOPY);
			
					
		}


		break;
	case WM_LBUTTONDOWN:
		if (hBitmap==NULL)
		{			
			hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
				LR_LOADFROMFILE);
			
			hdc=GetDC(hwnd);
			hTempDC=CreateCompatibleDC(hdc);
			
			hOldBitmap=(HBITMAP)SelectObject(hTempDC, hBitmap);

			GetObject(hBitmap, sizeof(BITMAP), &bitmap);

			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);		
			SetGraphicsMode(hdc, GM_ADVANCED);
			translate(coord.x, coord.y, xForm1);
			counter=0;
				
			SetTimer(hwnd, 1, 10, NULL);	
			
		}
		else
		{					
			coord.x=LOWORD(lParam);
			coord.y=HIWORD(lParam);	
			counter=0;

			translate(coord.x, coord.y, xForm1);	
			
			SetTimer(hwnd, 1, 100, NULL);	
		}

		*/
	
		//
/*
	hdc=GetDC(hwnd);
		SetWindowOrgEx(hdc, -10, -100, &origin);
		count=0;
		checkDisplay(myPrintMethod);
		*/

		//result=BitBlt(hdc, coord.x, coord.y, bitmap.bmWidth, bitmap.bmHeight, hTempDC,
		//	0, 0, SRCCOPY);
		//SelectObject(hTempDC, NULL);
		//DeleteDC(hTempDC);
		
		//ReleaseDC(hwnd, hdc);
		//alphaBlendBitmap(hwnd, hBitmap, coord, 40);

		//motionBlur(hwnd, coord, hBitmap);

		//drawSun(hwnd, coord, 50, 60, 36);
		
		/*
		hBitmap=(HBITMAP)LoadImage(NULL, "mygirl.bmp", IMAGE_BITMAP, 0, 0, 
			LR_LOADFROMFILE);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		
		hdc=GetWindowDC(hwnd);

		clientAreaOrg(origin, hwnd);
		//SetWindowOrgEx(hdc, -origin.x, -origin.y, &origin);
		coord.x+=origin.x;
		coord.y+=origin.y;
		
		GetObject(hBitmap, sizeof(BITMAP), &bitmap);
		
		hTempDC=CreateCompatibleDC(hdc);
		SelectObject(hTempDC, hBitmap);
		//SetWindowOrgEx(hdc, -origin.x, -origin.y, &origin);
		result=SetGraphicsMode(hdc, GM_ADVANCED);

		
		//translate(0, 0, xForm1);

		for (i=0; i<bitmap.bmHeight; i+=10)
		{
			translate(coord.x+i, coord.y+i, xForm1);
			rotate(30.0+i*2.0, xForm2);
			result=CombineTransform(&xForm, &xForm2, &xForm1);

			result=SetWorldTransform(hdc, &xForm);
			//errHandle("setworld transform");

			result=BitBlt(hdc, 0, i, bitmap.bmWidth, 
					10, hTempDC, 0, i, SRCINVERT);
		}
		

		//CombineTransform(&xForm, &xForm1, &xForm2);

		//CombineTransform(&xForm, &xForm2, &xForm1);
		

		//result=CombineTransform(&xForm, &xForm2, &xForm1);

		
		DeleteObject(hBitmap);
		DeleteDC(hTempDC);
		ReleaseDC(hwnd, hdc);
		*/

		/*
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		clientAreaOrg(origin, hwnd);
		hdc=GetWindowDC(hwnd);
		radiant=30.0/360.0*2.0*3.141;
		hImageBitmap=(HBITMAP)LoadImage(NULL, "idchar.bmp", IMAGE_BITMAP, 0, 0, 
			LR_LOADFROMFILE);
		hTempDC=CreateCompatibleDC(hdc);
		for (int i=0; i<6; i++)
		{
			hBitmap=GetRotatedBitmap(hdc, hImageBitmap, radiant*i,
				RGB(0,0,0));			
			//hBitmap=mySprite.hImageBitmap;
			GetObject(hBitmap, sizeof(BITMAP), &bitmap);
			
			
			SelectObject(hTempDC, hBitmap);
			//SelectObject(hTempDC, mySprite.hImageBitmap);
			
			sprintf(msg, "bitmap[%d,%d]coord[%d,%d]radiant[%f]", bitmap.bmWidth, 
				bitmap.bmHeight, coord.x+origin.x, coord.y+origin.y, radiant);
			SetWindowText(hwnd, msg);

			result=BitBlt(hdc, coord.x+origin.x, coord.y+origin.y, bitmap.bmWidth, 
				bitmap.bmHeight, hTempDC, 0, 0, SRCINVERT   );
			DeleteObject(hBitmap);
		}
		DeleteDC(hTempDC);
		ReleaseDC(hwnd, hdc);
		*/
		

		//myHex.init(rect.right, rect.bottom, mySprite.bitmap.bmWidth/0.612/2);
/*
		hdc=GetWindowDC(hwnd);
		GetWindowOrgEx(hdc, &origin);
		ReleaseDC(hwnd, hdc);
		myBackGround.drawBackGround(rect);
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
		
		myHex.coord2hex(coord, hex);
		myHex.hex2rect(hex, rect);
		myHex.hex2center(hex, center);
		sprintf(buf, "coord[%d,%d]hex[%d,%d]rect[%d,%d]center[%d,%d]", coord.x, coord.y, 
			hex.x, hex.y, rect.left, rect.top, center.x, center.y);
		SetWindowText(hwnd, buf);
		//
		fillHexagon(hex, RGB(255,0,0));
*/
	
		//hdc=GetWindowDC(hwnd);
		//GetClientRect(hwnd, &rect);
		//DPtoLP(hdc, (LPPOINT) &rect, 2); 
		//coord.x=LOWORD(lParam);
		//coord.y=HIWORD(lParam);
		//SetGraphicsMode(hdc, GM_ADVANCED);
		//doTransform(ROTATE, xForm);
		//translate(250, 0, xForm2);
		//scale(5, 5, xForm);
		//shear(3, 3, xForm);
		//CombineTransform(&xForm, &xForm1, &xForm2);
		//rotate(60, xForm);
		//memcpy(&xForm2, &xForm, sizeof(XFORM));
		//CombineTransform(&xForm, &xForm1, &xForm2);
		//memcpy(&xForm, &xForm1, sizeof(XFORM));
		//xForm.eDx=xForm2.eDx;
		//xForm.eDy=xForm2.eDy;

		
		//SetViewportOrgEx(hdc, 100, 100, NULL);
		//SetWindowOrgEx(hdc, 100, 100, NULL);
		//result=SetWorldTransform(hdc, &xForm);
		
		//result=BitBlt(hdc, 100, 100, mySprite.bitmap.bmWidth, 
		//	mySprite.bitmap.bmHeight, mySprite.hBitmapDC, 0, 0, SRCCOPY);
		//errHandle("bitblt:");
		//mySprite.drawSprite(hdc, coord.x, coord.y);
		
	

  		/*
		versionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&versionInfo);
		sprintf(msg, "major[%d]minor[%d]build[%d]info[%s]",
			versionInfo.dwMajorVersion, versionInfo.dwMinorVersion, 
			versionInfo.dwBuildNumber, versionInfo.szCSDVersion);
		TextOut(hdc, 50, 100, msg, strlen(msg));
		*/


/*	case WM_RBUTTONDOWN:

		GetClientRect(hwnd, &rect);
		clientAreaOrg(origin, hwnd);
		hdc=GetWindowDC(hwnd);
		hBrush=CreateSolidBrush(RGB(0, 255, 0));
		//DrawState(hdc, (HBRUSH)GetStockObject(WHITE_BRUSH), myProc, 0, 0, 0, 0, 0, 0, 0);
		color=GetBkColor(hdc);
		
		
		//SetWindowOrgEx(hdc, -origin.x, -origin.y, &origin); 
		//GetWindowOrgEx(hdc, &origin);

		rect.left+=40;
		rect.top+=50;
		rect.right/=2;
		rect.bottom/=2;
		region.left=100;
		region.top=70;
		region.right=region.left+50;
		region.bottom=region.top+20;
		//DrawFocusRect(hdc, &rect);
		//FrameRect(hdc, &rect, (HBRUSH)GetStockObject(GRAY_BRUSH));
		//DrawEdge(hdc, &rect, EDGE_BUMP, BF_BOTTOMRIGHT|BF_TOPRIGHT);

		result=GrayString(hdc, hBrush, NULL, (long)(str), 10, rect.left, rect.top, 
			10*10, 20);

		result=DrawText(hdc,  "hello world", 11, &region, DT_CALCRECT|DT_CENTER);
		SetTextColor(hdc, RGB(255,0,0));
		SetBkColor(hdc, RGB(0, 255, 0));
		SetBkMode(hdc, TRANSPARENT);


		TextOut(hdc, 100, 100, "hello world", 11);
		DrawCaption(hwnd, hdc, &region, DC_INBUTTON);
		ReleaseDC(hwnd, hdc);
		//DrawAnimatedRects(hwnd, IDANI_CAPTION, &rect, &region);

		
		myHex.init(rect.right, rect.bottom, mySprite.bitmap.bmWidth/0.612/2);
		//myHex.hex2rect(hex, rect);
		doDrawHexagon(myHex.size, RGB(255, 0, 0));
		myBackGround.init(hwnd);
		myBackGround.saveBackGround(rect);
		DeleteObject(hBrush);


		break;
		*/


/*

		hdc=GetWindowDC(hwnd);
		mode=SetGraphicsMode(hdc, GM_ADVANCED);

		xForm.eM11 = (FLOAT) 0.8660; 
        xForm.eM12 = (FLOAT) 0.5000; 
        xForm.eM21 = (FLOAT) -0.5000; 
        xForm.eM22 = (FLOAT) 0.8660; 
        xForm.eDx  = (FLOAT) 0.0; 
        xForm.eDy  = (FLOAT) 0.0; 
        mode=SetWorldTransform(hdc, &xForm); 
		ReleaseDC(hwnd, hdc);

  */