#include "myWindow.h"
#include <stdio.h>
#include <windows.h>
#include "myWindowProc.h"

const char* szAppName="FirstWindow";

MyWindow myWindow;
extern HBRUSH hBGBrush;

void clientAreaOrg(POINT& point, HWND hwnd)
{
	RECT rect;
	point.x=point.y=0;
	if (hwnd==NULL)
	{
		GetWindowRect(myWindow.hGlobalWnd,  &rect);
		ClientToScreen(myWindow.hGlobalWnd, &point);
	}
	else
	{
		GetWindowRect(hwnd,  &rect);
		ClientToScreen(hwnd, &point);
	}	
	
	point.x-=rect.left;
	point.y-=rect.top;
}


void MyWindow::init(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpComdLine, int nShowCmd)
{
	width=800;
	height=600;
	fullScreen=false;
	sprintf(windowTitle, "%s",  szAppName);
	myWindowProcCount=0;
	hGlobalInstance=hInstance;
	myShowCmd=nShowCmd;
}


long CALLBACK myDefaultWinProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	for (int i=0; i<myWindow.myWindowProcCount; i++)
	{
		myWindow.myWindowProcArray[i](hwnd, message, wParam, lParam);	

	}
	switch (message)
	{
	case WM_DESTROY:	
		PostQuitMessage(0);
		break;
	//case WM_MOVE:


	default:
		return DefWindowProc(hwnd, message, wParam, lParam);
		break;
	}
	return 0L;
}



bool MyWindow::registerMyWindowProc(MyWindowProcType myWindowProc)
{
	if (myWindowProcCount==MaxWindowProcCount)
	{
		return false;
	}
	for (int i=0; i<myWindowProcCount; i++)
	{
		if (myWindowProcArray[i]==myWindowProc)
		{
			return true;
		}
		if (myWindowProcArray[i]==NULL)
		{
			myWindowProcArray[i]=myWindowProc;
			return true;
		}
	}

	myWindowProcArray[myWindowProcCount++]=myWindowProc;
	return true;
}

bool MyWindow::unRegisterMyWindowProc(MyWindowProcType myWindowProc)
{
	for (int i=0; i<myWindowProcCount; i++)
	{
		if (myWindowProcArray[i]==myWindowProc)
		{
			myWindowProcArray[i]=NULL;
			if (i+1==myWindowProcCount)
			{
				myWindowProcCount--;
			}
			return true;
		}
	}
	return false;
}



BOOL MyWindow::mainLoop()
{
	//WINDOWINFO   wndInfo;
	//memset(&wndClass, 0, sizeof(WNDCLASSEX));
	POINT point;
	
	wndClass.cbSize=sizeof(WNDCLASSEX);
	wndClass.cbClsExtra=0;
	wndClass.cbWndExtra=0;
	MSG msg;
	if (fullScreen)
	{
		width=GetSystemMetrics(SM_CXSCREEN);
		height=GetSystemMetrics(SM_CYSCREEN);
	}
	//myRect.left=left=0;
	//myRect.top=top=0;
	myRect.left=0;
	myRect.top=0;
	
	myRect.right=width;
	myRect.bottom=height;

	wndClass.hInstance=hGlobalInstance;
	if ((wndClass.hIcon=LoadIcon(NULL, IDI_APPLICATION))==NULL)
	{
		sprintf(errMsg, "load icon failed #%d", GetLastError());
		return FALSE;
	}
	wndClass.style=CS_HREDRAW|CS_VREDRAW;
	if ((wndClass.hCursor=LoadCursor(NULL, IDC_ARROW))==NULL)
	{
		sprintf(errMsg, "load cursor failed #%d", GetLastError());
		return FALSE;
	}


	wndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wndClass.lpszClassName=szAppName;
	wndClass.lpfnWndProc=myDefaultWinProc;
	//wndClass.lpszMenuName="SAMPLEMENU";
	if (!RegisterClassEx(&wndClass))
	{
		return FALSE;
	}

	hGlobalWnd=CreateWindow(szAppName, windowTitle, WS_OVERLAPPEDWINDOW,
		0, 0, width,
		height, NULL, NULL, hGlobalInstance, NULL);
	//GetClassLong(hGlobalWnd, 
	//int result=SetWindowPos(hGlobalWnd, NULL, 0, 0, width, height, SWP_FRAMECHANGED);


	//point.x=point.y=0;
	//ClientToScreen(hGlobalWnd, &point);
	//clientOrgX=point.x-left;
	//clientOrgY=point.y-top;
	ShowWindow(hGlobalWnd, myShowCmd);

	UpdateWindow(hGlobalWnd);
	
	//GetWindowInfo(hGlobalWnd, &wndInfo);
	//char buf[80];
	//sprintf(buf, "width=%d, height=%d", wndInfo.rcWindow.right-wndInfo.rcWindow.left,
	//	wndInfo.rcWindow.bottom-wndInfo.rcWindow.top);
	//SetWindowText(hGlobalWnd, buf);
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
