#include <windows.h>
#include "myWindowProc.h"
#include "myWindow.h"
#include "../mylibpng/png.h"
#include "../mylibpng/pngconf.h"
#include "../mylibpng/pngFile.h"

#include "errHandle.h"

static OPENFILENAME ofn;


#pragma comment(lib, "./lib/mylibpng.lib")
//#pragma comment(lib, "./lib/libpng.lib")
//#pragma comment(lib, "./lib/zlib.lib")


#define MARGIN 8

//extern "C"  BOOL PngLoadImage (PTSTR pstrFileName, png_byte **ppbImageData, 
//						int *piWidth, int *piHeight, int *piChannels, png_color *pBkgColor);
//extern "C" BOOL myPngLoadImage(PTSTR pstrFileName, 
//				   BITMAPINFO** bmHeader, png_color *pBkgColor);




/*
HBITMAP myLoadBitmap(HWND hwnd, POINT coord, TCHAR* pstrFileName)
{
	BITMAP bitmap;
	BLENDFUNCTION blendFunc;
	HDC hdc;
	HDC hMemDC;
	HBITMAP hBitmap;


	hdc=GetDC(hwnd);
	hMemDC=CreateCompatibleDC(hdc);
	if ((hBitmap=PngLoadBitmap(hdc, pstrFileName, RGB(255, 255,255)))==NULL)
	{
		return 0;
	}
	
	SelectObject(hMemDC, hBitmap);

	blendFunc.BlendOp=AC_SRC_OVER;
	blendFunc.BlendFlags=0;
	blendFunc.SourceConstantAlpha=255;
	blendFunc.AlphaFormat=AC_SRC_ALPHA;
	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	

	AlphaBlend(hdc, coord.x, coord.y, bitmap.bmWidth,
		bitmap.bmHeight, hMemDC, 0, 0,
		bitmap.bmWidth, 
		bitmap.bmHeight, blendFunc);

	//DeleteObject(hBitmap);
	DeleteDC(hMemDC);
	
	ReleaseDC(hwnd, hdc);
	return hBitmap;
}
*/


static TCHAR szFilter[] = TEXT ("PNG Files (*.PNG)\0*.png\0")
        TEXT ("All Files (*.*)\0*.*\0\0");
// Windows open-file functions

void PngFileInitialize (HWND hwnd)
{
    ofn.lStructSize       = sizeof (OPENFILENAME);
    ofn.hwndOwner         = hwnd;
    ofn.hInstance         = NULL;
    ofn.lpstrFilter       = szFilter;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 0;
    ofn.lpstrFile         = NULL;          // Set in Open and Close functions
    ofn.nMaxFile          = MAX_PATH;
    ofn.lpstrFileTitle    = NULL;          // Set in Open and Close functions
    ofn.nMaxFileTitle     = MAX_PATH;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrTitle        = NULL;
    ofn.Flags             = 0;             // Set in Open and Close functions
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = TEXT ("png");
    ofn.lCustData         = 0;
    ofn.lpfnHook          = NULL;
    ofn.lpTemplateName    = NULL;
}

BOOL PngFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
    PngFileInitialize(hwnd);
	ofn.hwndOwner         = hwnd;
    ofn.lpstrFile         = pstrFileName;
    ofn.lpstrFileTitle    = pstrTitleName;
    ofn.Flags             = OFN_HIDEREADONLY;
	
    return GetOpenFileName (&ofn);
}

BOOL PngFileSaveDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
	PngFileInitialize(hwnd);
    ofn.hwndOwner         = hwnd;
    ofn.lpstrFile         = pstrFileName;
    ofn.lpstrFileTitle    = pstrTitleName;
    ofn.Flags             = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	
    return GetSaveFileName (&ofn);
}

long CALLBACK pngLoader(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc, hMemDC;
	char msg[64];
	int result;
	BITMAPINFO* pBitmapInfo=NULL;
	BITMAPINFOHEADER   bitmapInfoHeader;
	static TCHAR pstrFileName[MAX_PATH];
	static TCHAR pstrTitleName[MAX_PATH];
	BITMAPFILEHEADER  *pbmfh;
    BITMAPINFOHEADER  *pbmih;
    BYTE              *pbImage;
	static HBITMAP hBitmap=NULL;
	BITMAP bitmap;

	BLENDFUNCTION blendFunc;
	COLORREF color;
	int counter=0, i, j;
	RGBQUAD* pQuad;
	const int Width=200;
	const int Height=400;
	unsigned char* pColor;
	unsigned int alpha;
	BITMAPINFO myBitmapInfo;
	POINT coord;
	int iRowBytes;
	HBRUSH hBrush;
	RECT rect;

	png_color bkgColor={127,127,127};
 
	switch(message)
	{
	case WM_CREATE:
		//PngFileInitialize (hwnd);
		break;
	case WM_RBUTTONDOWN:
		coord.x=LOWORD(lParam);
		coord.y=HIWORD(lParam);
	
		if (!PngFileOpenDlg (hwnd, pstrFileName, pstrTitleName))
		{
			//errHandle("why");
			return 0;
		}

		if (hBitmap!=NULL)
		{
			DeleteObject(hBitmap);
			hBitmap=NULL;
		}
/*
		//hBitmap=myLoadBitmap(hwnd, coord);
		hdc=GetDC(hwnd);
		PngLoadTransparent(pstrFileName, &pBitmapInfo, RGB(255,255,255));

		result=SetDIBitsToDevice(hdc, 0, 0, pBitmapInfo->bmiHeader.biWidth,
			pBitmapInfo->bmiHeader.biHeight, 0, 0, 0, pBitmapInfo->bmiHeader.biHeight,
			pBitmapInfo->bmiColors, pBitmapInfo, DIB_RGB_COLORS);

		ReleaseDC(hwnd, hdc);
		*/
		hdc=GetDC(hwnd);
		hBitmap=PngLoadBitmap(hdc, pstrFileName, RGB(0,0,0));
		hBrush=CreatePatternBrush(hBitmap);
		GetClientRect(hwnd, &rect);
		FillRect(hdc, &rect, hBrush);
		DeleteObject(hBrush);
		//DeleteObject(hBitmap);
		ReleaseDC(hwnd, hdc);


		break;
	case WM_LBUTTONDOWN:
		hdc=GetDC(hwnd);
		if (!PngFileSaveDlg(hwnd, pstrFileName, pstrTitleName))
		{
			return 0;
		}
		if (hBitmap==NULL)
		{
			return 0;
		}

		if (!PngSaveBitmap(hdc, hBitmap, pstrFileName))
		{
			return 0;
		}		
		ReleaseDC(hwnd, hdc);		
		break;
	}

	return 0L;
}

void testAlpha(HWND hwnd, LPARAM lParam)
{
	HDC hdc, hMemDC;
	char msg[64];
	int result;
	BITMAPINFO* pBitmapInfo=NULL;
	BITMAPINFOHEADER   bitmapInfoHeader;
	static TCHAR pstrFileName[MAX_PATH];
	static TCHAR pstrTitleName[MAX_PATH];
	BITMAPFILEHEADER  *pbmfh;
    BITMAPINFOHEADER  *pbmih;
    BYTE              *pbImage;
	HBITMAP hBitmap;
	BITMAP bitmap;

	BLENDFUNCTION blendFunc;
	static png_color          bkgColor = {127, 127, 127};
	COLORREF color;
	int counter=0, i, j;
	RGBQUAD* pQuad;
	const int Width=200;
	const int Height=400;
	unsigned char* pColor;
	unsigned int alpha;
	BITMAPINFO myBitmapInfo;
	POINT coord;
 
	hdc=GetDC(hwnd);
	hMemDC=CreateCompatibleDC(hdc);
	coord.x=LOWORD(lParam);
	coord.y=HIWORD(lParam);
	
	pbImage=new unsigned char[Width*Height*4];
	for (i=0; i<Width; i++)
	{
		for (j=0; j<Height; j++)
		{
			pColor=pbImage+(j*Width+i)*4;
			color=GetPixel(hdc, i+300, j+300);
			pColor[0]=GetBValue(color);
			pColor[1]=GetGValue(color);
			pColor[2]=GetRValue(color);
			
			//alpha=rand()%256;
			if (i>j)
			{
				pColor[3]=0;
			}
			else
			{
				pColor[3]=255;
			}
		
		}
	}
	memset(&myBitmapInfo.bmiHeader, 0, sizeof(BITMAPINFOHEADER));
	myBitmapInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	myBitmapInfo.bmiHeader.biCompression=BI_RGB;

	myBitmapInfo.bmiHeader.biWidth=Width;
	myBitmapInfo.bmiHeader.biHeight=Height;
	myBitmapInfo.bmiHeader.biPlanes=1;
	myBitmapInfo.bmiHeader.biBitCount=32;

	hBitmap=CreateDIBitmap(hdc, &myBitmapInfo.bmiHeader, CBM_INIT,	pbImage,
		&myBitmapInfo, DIB_RGB_COLORS);

	SelectObject(hMemDC, hBitmap);

	blendFunc.BlendOp=AC_SRC_OVER;
	blendFunc.BlendFlags=0;
	blendFunc.SourceConstantAlpha=255;
	blendFunc.AlphaFormat=AC_SRC_ALPHA;

	result=AlphaBlend(hdc, coord.x, coord.y, Width, 
		Height, hMemDC, 0, 0,
		Width, 
		Height, blendFunc);
	
	DeleteDC(hMemDC);
	DeleteObject(hBitmap);
	//delete[]pbImage;

	ReleaseDC(hwnd, hdc);
}