#include <windows.h>
#include <stdio.h>
#include "myWindow.h"
#include "sprite.h"
#include "errHandle.h"
#include "util.h"

//extern HBRUSH hBGBrush;
extern BackGround myBackGround;

int Animation::timerID=100;

//HDC Sprite::hBKDC=NULL;

void reDrawBackground(HDC hdc, int x, int y, int w, int h)
{
	//HBRUSH hOldBrush;
	//hOldBrush=(HBRUSH)SelectObject(hdc, hBGBrush);

	
	//SelectObject(hdc, hOldBrush);
}

void drawSprite(HDC hdc, HDC hdcBitmap, HDC hMaskDC, int x, int y, int w, int h)
{

}

//by default it is white-background
void Sprite::init(HWND hwnd, char* name, bool fromFile)
{
	COLORREF bgColor, oldBgColor;
	HDC hdc;
	hdc=GetWindowDC(hwnd);
	if (!fromFile)
	{
		hImageBitmap=(HBITMAP)LoadImage(myWindow.hGlobalInstance, name, IMAGE_BITMAP, 0, 0, 
			LR_DEFAULTCOLOR);	
	}
	else
	{
		hImageBitmap=(HBITMAP)LoadImage(NULL, name, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	
	}
	if (hImageBitmap==NULL)
	{

		errHandle("load image failed");
	}

	SAFE_CALL((hBitmapDC=CreateCompatibleDC(hdc)), "load bitmap");
	SAFE_CALL((hMaskDC=CreateCompatibleDC(hdc)), "CREATE COMPATIBLE DC");
	/*
	if (hBKDC==NULL)
	{
		SAFE_CALL((hBKDC=CreateCompatibleDC(hdc)), "create bk dc");
	}
	*/

	GetObject(hImageBitmap, sizeof(BITMAP), &bitmap);

	SelectObject(hBitmapDC, hImageBitmap);

	SAFE_CALL((hMaskBitmap=CreateBitmap(bitmap.bmWidth, bitmap.bmHeight, 1, 1, NULL)),
		"CREATE MASK BITMAP");



	SelectObject(hMaskDC, hMaskBitmap);

	bgColor=GetPixel(hBitmapDC, 0, 0);
	oldBgColor=SetBkColor(hBitmapDC, bgColor);
	StretchBlt(hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hBitmapDC, 
		0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
	SetBkColor(hBitmapDC, oldBgColor);
	ReleaseDC(hwnd, hdc);
	x=y=-1;
	w=SpriteWidth;
	h=SpriteHeight;
	//BitBlt(hBitmapDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hBitmapDC, 0, 0, SRCINVERT);
}


void Sprite::draw(HDC hdc, int x, int y)
{
	//StretchBlt(hdc, x, y, w, h, hdc, x, y, bitmap.bmWidth, bitmap.bmHeight, PATCOPY);
	
	StretchBlt(hdc, x, y, w, h, hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCAND );

	StretchBlt(hdc, x, y, w, h, hBitmapDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCPAINT);

}


void Animation::drawAnimation(HWND hwnd, int myX, int myY, unsigned int elapseTime)
{
	POINT point;
	point.x=myX;
	point.y=myY;
	ClientToScreen(hwnd, &point);
	x=point.x;
	y=point.y;
	elapse=elapseTime;
	index=0;
	myTimerID=timerID++;
	hBkBrush=(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND);
}


void Animation::init(HWND hwnd, char* name, bool fromFile, bool jpeg)
{
	char buf[256];
	index=0;

	for (int i=0; i<SpriteCount; i++)
	{
		if (fromFile)
		{
			if (!jpeg)
			{
				sprintf(buf, "%s%d.bmp", name, i+1);
				
				sprite[i].init(hwnd, buf, fromFile);
			}
		}
	}
	w=sprite[0].w;
	h=sprite[0].h;
	x=y=oldX=oldY=-1;
	
}

void Sprite::halfBright(HWND hwnd, int x, int y)
{
	const unsigned int Mask=0x007F7F7F;
	HDC hdc;
	BYTE r, g, b;
	POINT point;
	COLORREF myColor;
	hdc=GetWindowDC(hwnd);
	point.x=point.y=0;
	ClientToScreen(hwnd, &point);

	for (int row=y+point.y; row<y+point.y+h; row++)
	{
		for (int col=x+point.x; col<x+point.x+w; col++)
		{
			myColor=GetPixel(hdc, col, row);
			/*
			r=GetRValue(myColor)>>1;
			g=GetGValue(myColor)>>1;
			b=GetBValue(myColor)>>1;
			SetPixel(hdc, col, row, RGB(r, g, b));
			*/
			myColor>>=1;
			myColor&=Mask;
			SetPixel(hdc, col, row, myColor);
			
		}
	}
	ReleaseDC(hwnd, hdc);

}

void Sprite::doubleBright(HWND hwnd, int x, int y)
{
	const unsigned int Mask=0x00FEFEFE;
	BYTE r, g, b;
	COLORREF myColor;
	HDC hdc;
	POINT point;
	point.x=point.y=0;
	ClientToScreen(hwnd, &point);
	hdc=GetWindowDC(hwnd);	
	for (int row=y+point.y; row<y+point.y+h; row++)
	{
		for (int col=x+point.x; col<x+point.x+w; col++)
		{
			myColor=GetPixel(hdc, col, row);
			
			r=min(GetRValue(myColor)<<1, 255);
			g=min(GetGValue(myColor)<<1, 255);
			b=min(GetBValue(myColor)<<1, 255);
			SetPixel(hdc, col, row, RGB(r, g, b));
			/*
			myColor<<=1;
			myColor&=Mask;
			
			SetPixel(hdc, col, row, myColor);
			*/
		}
	}
	ReleaseDC(hwnd, hdc);

}

void Sprite::drawSprite(HWND hwnd, int myX, int myY)
{
	HDC hdc;
	POINT point;
	RECT rect;
	point.x=0;
	point.y=0;

	//background uses clientarea coord.
	if (x!=-1&&y!=-1)
	{
		rect.left=x;
		rect.top=y;
		rect.right=rect.left+bitmap.bmWidth;
		rect.bottom=rect.top+bitmap.bmHeight;
		myBackGround.drawBackGround(rect);		
	}

	//clientAreaOrg(point, hwnd);
	hdc=GetDC(hwnd);
	
	StretchBlt(hdc, myX, myY, w, h, hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCAND );

	StretchBlt(hdc, myX, myY, w, h, hBitmapDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCPAINT);
	x=myX;
	y=myY;

	ReleaseDC(hwnd, hdc);
}


void Sprite::drawSprite(HDC hdc, const RECT& rect, bool eraseBkGround)
{
	RECT bkRect;
	int result;

	//background uses clientarea coord.
	if (eraseBkGround)
	{
		bkRect.left=x;
		bkRect.top=y;
		bkRect.right=bkRect.left+bitmap.bmWidth;
		bkRect.bottom=bkRect.top+bitmap.bmHeight;
		myBackGround.drawBackGround(bkRect);		
	}

	//clientAreaOrg(point);
	
	result=StretchBlt(hdc, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top,
		hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCAND );

	result=StretchBlt(hdc, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top,
		hBitmapDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCPAINT);
}

void Sprite::drawSprite(HDC hdc, int myX, int myY)
{
	POINT point;
	RECT rect;
	point.x=0;
	point.y=0;
	int result;

	//background uses clientarea coord.
	if (x!=-1&&y!=-1)
	{
		rect.left=x;
		rect.top=y;
		rect.right=rect.left+bitmap.bmWidth;
		rect.bottom=rect.top+bitmap.bmHeight;
		myBackGround.drawBackGround(rect);		
	}

	//clientAreaOrg(point);
	
	result=StretchBlt(hdc, myX, myY, w, h, hMaskDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCAND );

	result=StretchBlt(hdc, myX, myY, w, h, hBitmapDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCPAINT);
	x=myX;
	y=myY;
}

void Animation::draw(HWND hwnd)
{
	HDC hdc;
	HBRUSH hOldBrush;
	POINT point;
	hdc=GetWindowDC(hwnd);
	point.x=point.y=0;
	ClientToScreen(hwnd, &point);
	
	hOldBrush=(HBRUSH)SelectObject(hdc, hBkBrush);
	SetBrushOrgEx(hdc, point.x, point.y, &point);
	if (index==0)
	{
		if (oldX!=-1&&oldY!=-1)
		{
			reDrawBackground(hdc, oldX, oldY, w, h);
		}
	}
	sprite[index].draw(hdc, x, y);
	SetBrushOrgEx(hdc, point.x, point.y, &point);
	SelectObject(hdc, hOldBrush);
	index++;
	if (index==SpriteCount)
	{
		KillTimer(hwnd, myTimerID);
		index=0;
		oldX=x;
		oldY=y;
	}
	ReleaseDC(hwnd, hdc);
}




	/*
		hBrush=CreateSolidBrush(RGB(230,230,230));
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		SetBrushOrgEx(hdc, point.x, point.y, &point);
		//DPSnao  
		//BitBlt(hdc, x, y, w, h, sprite[0].hMaskDC, 0, 0, 0x00BA0B09);
		//SDPSnaoxn
		//BitBlt(hdc, x, y, w, h, sprite[0].hMaskDC, 0, 0, 0x00891B08);
		//
		BitBlt(hdc, x, y, w, h, sprite[0].hMaskDC, 0, 0, 0x00200F09);
		//BitBlt(hdc, x, y, w, h, sprite[0].hMaskDC, 0, 0, 0x00550009);
		
		SetBrushOrgEx(hdc, point.x, point.y, &point);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		DeleteObject(hBrush);


		hBrush=(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		SetBrushOrgEx(hdc, point.x, point.y, &point);
		BitBlt(hdc, x, y, w, h, sprite[0].hMaskDC, 0, 0, 0x00590609);
		SetBrushOrgEx(hdc, point.x, point.y, &point);
		hBrush=(HBRUSH)SelectObject(hdc, hBrush);
		*/






